#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>

#include "func_extern.h"
#include "control.h"
#include "motor.h"
#include "../original/uss_control.h"

extern time_t start_time;
extern FILE *fp;

int correction(void){
	int uss_2=0,uss_4=0;
	int uss_err=0;
	double x=0,th=0;
	int correct_angle=0;
	int dir=0;
	int par[5];

	printf("correction function start\n");

	usleep(S_TIME);
	uss_2=uss_get(2);
	usleep(S_TIME);
	uss_4=uss_get(4);
	fprintf(fp,"correct uss2 = %d,uss4 = %d\n",uss_2,uss_4);
	fclose_open('f');
	if(uss_2 == 20 && uss_4 == 20)return -1;
	if(uss_2 > 50 || uss_4 > 50)return -1;
	uss_err=uss_4-(L2_DEF - L1_DEF) - uss_2;
	if(abs(uss_err) > 15)return -1;
	if(abs(uss_err) < 2)return -1;
	x=(double)uss_err/L1_L2_DIS;
	th=asin(x);
	correct_angle=-180*th/PI;
	printf("uss_err = %d,x = %f",uss_err,x);
	printf("correct angle = %d,%f\n",correct_angle,th);
	if(th != 0){
		time( &start_time );
		if(correct_angle > 0)dir=1;
		else dir=-1;
		par[0]=correct_angle;
		par[1]=30*dir;
		par[5]=5;
		pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
		pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,par);
		pthread_join(motor_task1, NULL);
		pthread_join(timer_task, NULL);
	}
	return 0;
}
