/* declaration of external functios */
#ifndef __FUNC_EXTERN_H__
#define __FUNC_EXTERN_H__

#include <termios.h>
#include <stdint.h>
//MAIN
extern int initialize(void);
extern int correction(void);

//USS
extern int uss_get(int);

//CAM
extern int img_update(char*, int, int);

//SERIAL PORT I/O
extern int set_serial_port(int, struct termios*);
extern void close_serial_port(int, struct termios*);
extern int put_serial_char(int, char);
extern int put_serial_string(int, char*);
extern int get_serial_char(int);

//MOTOR
extern int motor_stop_thread();
extern int motor_send_control_packet (int, uint8_t, uint8_t, uint8_t);
extern int motor_recv_status_packet (int, int8_t*, uint16_t*, int32_t*);
extern int motor_send_start_packet (int);
extern int motor_send_stop_packet (int);
extern int motor_send_clear_packet(int);

//ORIGINAL FUNCTION
extern int exit_detect(char);
extern void *uss_thread(void);
extern void *original_straight_thread(void*);
//extern void *sub_motor_thread(void);
extern void *const_straight_thread(void*);
extern void *const_rotate_thread(void*);
extern void *e_const_straight_thread(void*);
extern void *e_const_rotate_thread(void*);
//extern void *const_circle_threaed(void*);
//extern void motor_open(void);
//extern void motor_close(void);
extern void introduction1(void);
extern void introduction2(void);
extern void *irs_ts_ws_thread(void);
extern void irs_ts_ws_get(void);
extern int DB_knock(char* , int*);
extern int conor_detect(char*,int*,int*);
extern void *mk_right_turn(void*);
extern void *mk_left_turn(void*);
extern void timer_thread();
extern void judge_state(void);
extern void flag_reset(void);
//extern void kobeya_control(void);
extern void kobeya_left_control(void);
extern void rotary_control(void);
extern void fclose_open(char);
extern void log_printf(void);


//TALK
extern int talk(char*);
extern int talk_stop(void);

#endif
