//headders
#include <stdio.h>
#include <string.h>
#include <highgui.h>
#include <cv.h>
#include <cxcore.h>
#include "ball_detect_extern.h"
#include "use_window.h"
//Camera
#define CAM_WIDTH	320
#define CAM_HEIGHT	240
//col_threshold用0萔
#define THRE_H_MIN	0
#define THRE_H_MAX	10
#define THRE_S_MIN	90
#define THRE_S_MAX	255
#define THRE_V_MIN	60
#define THRE_V_MAX	255
#define CODE		"HSV"
//cvCanny用定数
#define CANNY_THRESHOLD1	50
#define CANNY_THRESHOLD2	100
#define APERTURE_SIZE		3
//cvSmooth用定数
#define SMOOTH_PARAM1		9
#define SMOOTH_PARAM2		9

int ball_detect(void){
	int nx, ny;
	int key;
	double dis=-999, deg=-999;
	short *labeling_data=NULL;
	char *filename = "input.jpg";
	IplImage *inputImage = 0,
			 *thresholdImage,
			 *cannyImage,
			 *smoothImage,
			 *circleImage;
//	IplImage *frameImage;
//	CvCapture *capture;
	
/*	if((capture = cvCreateCameraCapture(CV_CAP_ANY)) == NULL){
		printf("カメラが見つかりません\n");
		return -1;
	}
*/	
	img_update(filename, CAM_WIDTH, CAM_HEIGHT);
//	while(1){
//		frameImage = cvQueryFrame(capture);
		if(inputImage == 0){
			inputImage = cvLoadImage(filename, CV_LOAD_IMAGE_ANYCOLOR);
			thresholdImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			cannyImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			smoothImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			circleImage = cvCreateImage(cvGetSize(inputImage), IPL_DEPTH_8U, 1);
			nx = inputImage->width; 
			ny = inputImage->height;
			labeling_data = (short*)malloc(sizeof(short)*nx*ny);
		}

//		cvResize(frameImage, inputImage, CV_INTER_NN);
		
//		if(frameImage->origin != 0) cvFlip(inputImage, inputImage, 0);
		
		//color threshold
		col_threshold(inputImage, thresholdImage, THRE_H_MIN, THRE_H_MAX, THRE_S_MIN, THRE_S_MAX, THRE_V_MIN, THRE_V_MAX, CODE);

		//Erode & Dilate
		cvErode(thresholdImage, thresholdImage, NULL, 2);
		cvDilate(thresholdImage, thresholdImage, NULL, 5);

		//Canny	edge
		cvCanny(thresholdImage, cannyImage, CANNY_THRESHOLD1, CANNY_THRESHOLD2, APERTURE_SIZE);

		//Smooth
		cvSmooth(cannyImage, smoothImage, CV_GAUSSIAN, SMOOTH_PARAM1, SMOOTH_PARAM2, 0, 0);

		//HoughCircles
		hough_circle(smoothImage, circleImage, (double*)&dis, (double*)&deg);	//disとdegを参照することで、ボールまでの距離と角度が分かる

		//外部変数に代入
		ball.dis = (int)(dis);
		ball.deg = (int)(deg);
		
#ifdef __USE_CV_WINDOW__
		//show images
		cvShowImage(inputIMG, inputImage);
		cvShowImage(windowNamecolThreshold, thresholdImage);
		cvShowImage(windowNameHoughCircle, circleImage);
#endif
		//quit program
		key = cvWaitKey(10);
/*		if(key == 'q'){
			break;
		}
*/
//	}//while
	
	free(labeling_data);
//	cvReleaseCapture(&capture);
	cvReleaseImage(&inputImage);
	cvReleaseImage(&thresholdImage);
	cvReleaseImage(&cannyImage);
	cvReleaseImage(&smoothImage);
	cvReleaseImage(&circleImage);
	
	return 0;
}
