#ifndef __CONTROL_H__
#define __CONTROL_H__


#include <stdint.h>
/* movement paramter */
#define circle_radious 360	/* circle diameter of going arround a post */
/* USS measurment parmeter */
#define USS_MAX 150		/* POST distace maxmimum [cm]*/
#define USS_MIN 20 		/* POST distace minimum [cm]*/
#define MCENTER_USS3_DIS 138		/* Distance between MIRS center and USS3 */
#define MCENTER_USS12_DIS 120		/* Distance between MIRS center and USS1,2 */
#define USS12_DIFF  0		/* USS Diffrence = USS1 - USS2  */
#define USS_CORRECT -30 /* Difference of USS data from correct distance */
/* MOTOR measurement parameter */
//#define Kp 30
#define Kp 50
//#define Ki 5
#define Ki 3
#define W_RADIUS 57
#define G_RATIO 1.43
#define ENC_COUNT 360
#define VMAX 127
#define M_DELAY 1.2
#define PI 3.141592
#define MIRS_RADIUS 152
#define CIRCLE_RADIUS 350
#define MOTOR_CYCLE 100
#define t_par	(2*3.141592*W_RADIUS*G_RATIO/ENC_COUNT)

// tuning parameter 
#define POST_ANG_DIFF	-14 /* POST angle diffrence in post_search */
#define AROUND_ANG      360-10 /* Rotation Angle around post in post_circle */

struct ball{
	double dis;
	double deg;
};
/*
typedef struct _MotorInfo{
	int fd;
	int kp;
	int ki;
	int send_dis;//[mm]
	int t;//[msec]
	int recv_dis;//[mm]
	int speed;//[m/s]
	uint16_t pwm;
	int32_t puls;
}MotorInfo;
*/
typedef struct _MotorInfo{
	int8_t speed;
	uint16_t pwm;
	int32_t puls;
}MotorInfo;

struct target{
	double dis[10];
	double deg[10];
	int num[10];
};

MotorInfo ml;
MotorInfo mr;

pthread_mutex_t mutex_motor;
int mtask_flag;

// declaration of pthead type */ 
pthread_t uss_task;
pthread_t irs_code_task;
pthread_t irs_ts_ws_task;
pthread_t motor_task;

pthread_attr_t attr_irs_ts_ws;
pthread_attr_t attr_uss;
pthread_attr_t attr_motor;

struct sched_param sched_param;

volatile int fd0, fd1, fd2, fd3, fd4, fd5, fd6, ctl;

volatile char irs[4],ts[4],ws[4];       /*tuika*/

volatile int irs_flag,ts_flag,ws_flag;      /*tuika*/
volatile int uss_data;
volatile int target_code;
volatile int return_dist;
volatile int cor_ang;
volatile int uss12;

volatile int uss[4];

struct ball ball;
struct target target;

#endif
