/* declaration of external functios */
#ifndef __FUNC_EXTERN_H__
#define __FUNC_EXTERN_H__

#include <termios.h>
#include <stdint.h>
//MAIN
extern int initialize(void);
extern int search(int);
extern int correction(void);
//THREAD
extern void *motor_thread_straight(void*);
extern void *motor_thread_rotate(void*);
extern void *motor_thread_circle(void*);
//extern void *motor_noopt_thread_straight(void *arg);
//extern void *motor_noopt_thread_rotate(void *arg);
extern void *irs_ts_ws(void*);
extern void *uss_read(void*);
//IRS
extern int irs_code_get(int);
//USS
extern int uss_get(int);
//WEBCAM
extern int ball_detect(void);
extern int num_detect(int);
//SERIAL PORT I/O
extern int set_serial_port(int, struct termios*);
extern void close_serial_port(int, struct termios*);
extern int put_serial_char(int, char);
extern int put_serial_string(int, char*);
extern int get_serial_char(int);
//MOTOR
//extern int motor_noopt(int*);
//extern int motor(char,int,int);
extern int motor(char,int*);
//extern int motor_thread(char,int,int);
extern int motor_thread(char,int*);
extern void motor_straight(void*);
extern void motor_rotate(void*);
extern void motor_circle(void*);
extern int motor_stop();
extern int motor_send_control_packet (int, uint8_t, uint8_t, uint8_t);
extern int motor_recv_status_packet (int, int8_t*, uint16_t*, int32_t*);
extern int motor_send_start_packet (int);
extern int motor_send_stop_packet (int);
extern int motor_send_clear_packet(int);

#endif
