/*
	番号の書かれたゲートを探索し、正体。
	その後、数字認識を行い、指定された番号だった場合、ゲートを潜る。
*/
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <highgui.h>
#include "../main/func_extern.h"
#include "../main/control.h"
#include "../uss/uss.h"
#include "../motor/motor.h"
#include "../main/show_window.h"

//待ち時間
int thread_create_uss_motor();
int thread_cancel_uss_motor();

int uss_num=2;
int dt[4];

int main(){

	int ret;
	int det_num;
	int sp_num=8;

	char c = 'r';
	int val= 360;
	int time;
	int abc,uss1=9999,uss2=9999;

	int s_val;

	time=abs(val)*10;

	dt[0] = val;
	dt[1] = time;
#ifdef __USE_CV_WINDOW__
	cvNamedWindow(inputIMG, CV_WINDOW_AUTOSIZE);
	cvNamedWindow(labelIMG, CV_WINDOW_AUTOSIZE);
	cvNamedWindow(threIMG, CV_WINDOW_AUTOSIZE);
#endif

	//初期化
	ret = initialize();

//開始
	//ターゲットの番号を標準入力で与える
	printf("Please input number :  ");
	s_val=scanf("%d",&sp_num);
	printf("Input number is %d\n",sp_num);
/*
	pthread_attr_init (&attr_motor);
	sched_param.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_motor, SCHED_RR);
	pthread_attr_setschedparam (&attr_motor, &sched_param);

	pthread_attr_init (&attr_uss);
	sched_param.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_uss, SCHED_RR);
	pthread_attr_setschedparam (&attr_uss, &sched_param);

	thread_create_uss_motor();

	while(1){

		while(1){
			printf("uss[%d] = %d\n",uss_num-1,uss[uss_num-1]);
			if(uss[uss_num-1]>USS_MIN && uss[uss_num-1]<USS_MAX){
                        	break;
			}
			usleep(130*1000);
		}
		thread_cancel_uss_motor();

		//exit(0);
		printf("thread cancel finish.\n");

		close(fd1);
		close(fd2);

		fd1 = open(M_PORT_L, O_RDWR);
		fd2 = open(M_PORT_R, O_RDWR);
*/
	while(1){

		while(1){
			//超音波センサの値を取得
			usleep(500000);
			uss1 = uss_get(1);
			usleep(500000);
			uss2 = uss_get(2);
			printf("uss1 = %d, uss2 = %d\n",uss1,uss2);
			//どちらかの超音波センサが反応していれば抜ける、それ以外は30度回転し、超音波センサの値取得に戻る
			if((uss1<=USS_MAX && uss1>USS_MIN) || (uss2<=USS_MAX && uss2>USS_MIN)){
				break;
			}else{
				dt[0]=30;dt[1]=30*7;
				motor('r',dt);
				//motor('r',30,30*7);
			}
		}
			
		//motor('r',20,20*7);

		//正体補正
		ret = correction();

		//abc=uss_get(2);
		//printf("abc=%d\n",abc);

		//正体補正ができていれば、番号認識を行う
		if(ret == 1){
			det_num=num_detect(3);
			printf("det_number= %d\n",det_num);
		}

		//番号が指定したターゲットのものならwhileを抜ける、それ以外は45度回転し、超音波センサの値取得に戻る
		if(det_num==sp_num){
			break;
		}else{
			//thread_create_uss_motor();
			dt[0]=45;dt[1]=45*7;
			motor('r',dt);
			//motor('r',45,45*7);
		}


	}

	//ゲートまでの距離を取得
	uss1 = uss_get(1);
	usleep(500000);
	//ゲートへ直進
	//motor('s', uss1*10+600, (uss1*10+600)*3);
	dt[0]=uss1*10+600;dt[1]=dt[0]*3;
	motor('s',dt);

//終了
	printf("program end ...\n");
	//pthread_join(uss_task,NULL);
	//pthread_join(motor_task,NULL);

	close(fd0);
	close(fd1);
	close(fd2);
	close(fd3);
	close(fd4);
	close(ctl);
#ifdef __USE_CV_WINDOW__
	cvDestroyWindow(inputIMG);
	cvDestroyWindow(labelIMG);
	cvDestroyWindow(threIMG);
#endif

	return 0;
}


int thread_create_uss_motor(){

		pthread_create(&uss_task, &attr_uss, &uss_read, (void *)uss_num);
		printf("uss thread created..\n");

		pthread_mutex_lock(&mutex_motor);
		motor_send_start_packet(fd1);
		motor_send_start_packet(fd2);
		pthread_mutex_unlock(&mutex_motor);
		pthread_create(&motor_task, &attr_motor, motor_thread_rotate, (void *)dt);
		//pthread_create(&motor_task, &attr_motor, motor_thread_rotate, dt);
		printf("motor thread created..\n");

		return 0;
}

int thread_cancel_uss_motor(){

		int ret=0;

		pthread_mutex_lock(&mutex_motor);
		motor_send_control_packet(fd1,0,Kp,Ki);
		motor_send_control_packet(fd2,0,Kp,Ki);
		usleep(150000);
		motor_send_stop_packet(fd1);
		motor_send_stop_packet(fd2);
		usleep(150000);
		motor_send_clear_packet(fd1);
		motor_send_clear_packet(fd2);
		usleep(150000);
		pthread_mutex_unlock(&mutex_motor);
		ret = pthread_cancel(motor_task);
		if(ret != 0) printf("error_mot\n");

		ret = pthread_cancel(uss_task);
		if(ret!= 0) printf("error_uss\n");
		printf("thread canceled...\n");
		return 0;

}
