#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>

#include "func_extern.h"
#include "control.h"

#define D_DEG 5
#define D_TIME 300
#define R_TIME 7500

//引数は、発見したターゲットが何個目かを示す。
extern struct target target;//発見したターゲットの情報
extern pthread_attr_t attr_uss, attr_motor;
extern pthread_t uss_task, motor_task;
extern int *uss;
extern int fd1;

int search(int *target_num){
	int deg1,deg2,i,esc;
	int mot[2];
	int v=15;
	int par[4];
	MotorInfo m_info_l;
	i = *target_num + 1;
	
	pthread_create(&uss_task, &attr_uss, &uss_read, (void *)1);
	
	motor_send_start_packet (fd1);
	motor_send_start_packet (fd2);
//	mot[0] = 360; mot[1] = R_TIME;
//	pthread_create(&motor_task, &attr_motor, motor_thread_rotate, (void*)mot);
	usleep(150*1000);
	motor_send_control_packet(fd1, v, Kp, Ki);
	motor_send_control_packet(fd2, -v, Kp, Ki);
	usleep(150*1000);

//	while(1){
		while(uss[0] >= USS_MAX){
			usleep(100000);
//			motor_recv_status_packet(fd1, &m_info_l.speed, &m_info_l.pwm, &m_info_l.puls);
		}
		motor_recv_status_packet(fd1, &m_info_l.speed, &m_info_l.pwm, &m_info_l.puls);
		esc = m_info_l.puls;
		deg1 = (int)(m_info_l.puls * t_par / MIRS_RADIUS * 180 /PI);
		
		while(uss[0] <= USS_MAX){
			usleep(100000);
		}
		motor_recv_status_packet(fd1, &m_info_l.speed, &m_info_l.pwm, &m_info_l.puls);
		deg2 = (int)((m_info_l.puls - esc) * t_par / MIRS_RADIUS * 180 /PI);
		
		motor_send_control_packet(fd1, 0, Kp, Ki);
		motor_send_control_packet(fd2, 0, Kp, Ki);
		usleep(150*1000);

		motor_send_stop_packet(fd1);
		motor_send_stop_packet(fd2);
		usleep(150*1000);
		motor_send_clear_packet(fd1);
		motor_send_clear_packet(fd2);
		usleep(150*1000)

		target.deg[i] = (deg2 - deg1)/2 + deg1;

		par[0]=(deg2 - deg1)/2;
		par[1]=(deg2 - deg1)/2*5;
		
		motor('r',par);
		
//	}
	pthread_cancel(uss_task);
	return 0;
}
