#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
#include <pthread.h>
#include <fcntl.h>
#include "func_extern.h"
#include "mg3.h"
#include "motor.h"

extern int fd1, fd2;

int motor(char sel,int *dt){

//	dt[0]=dis_or_deg; // distanece [mm]
//	dt[1]=time; // time [msec]

	motor_send_start_packet (fd1);
	motor_send_start_packet (fd2);
	if(sel == 's'){
		printf("t start\n");
		motor_straight(dt);
	}else if(sel == 'r'){
		motor_rotate(dt);
	}else if(sel == 'c'){
		motor_circle(dt);
	}else{
		printf("command_errer\n");
	}
	
	motor_send_stop_packet (fd1);
	motor_send_stop_packet (fd2);
	return 0;
}

int motor_stop(){
	motor_send_stop_packet (fd1);
	motor_send_stop_packet (fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	return 0;
}
	
void motor_straight(void *arg){
	int c_left,c_right;
	int *cmd=(int*)arg;
	int dis,time;
	float speed_l, speed_r;
	int x_l,x_r;
	int dir=1;
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
	printf("thread in\n");
	dis=cmd[0];
	time=cmd[1];
	
	speed_l=100*dis/(t_par*time);
	speed_r=100*dis/(t_par*time);
	
	v_l = (int)speed_l;
	v_r = (int)speed_r;

	printf("original vl = %d, vr = %d\n", v_l, v_r);

	if(abs(speed_l) > VLMAX){
		if(speed_l > 0){ v_l=VLMAX; v_r=VLMAX; }
		else{ v_l = -VLMAX; v_r = -VLMAX; }
	}else if(abs(speed_l) < VLMIN){
		if(speed_l > 0){ v_l=VLMIN; v_r=VLMIN; }
		else{ v_l = -VLMIN; v_r = -VLMIN; }
	}

	v_lm = v_l; v_rm = v_r;	

	if(v_l<0){dir=-1;}

	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	printf("send start\n");
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);

	usleep(130*1000);

	printf("end\n");
	c_left=0; c_right=0;
	while(1){
		printf("recv start\n");
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		//printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
		printf("end\n");		
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		printf("puls\tl = %d, r = %d\n", c_left, c_right);
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		//if(v_l <= 0 || v_r <= 0) break;

		if(abs(x_l-dis) > 100 || abs(x_r-dis) > 100){
			if(x_l - x_r > 10){
				v_lm=v_l-5; v_rm=v_r+5;
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
			}else if(x_r - x_l > 10){
				v_lm=v_l+5; v_rm=v_r-5;
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
			}else{
				motor_send_control_packet(fd1,v_l,Kp,Ki);
				motor_send_control_packet(fd2,v_r,Kp,Ki);
			}
		}

		//if(abs(x_l-dis) < 100 || abs(x_r-dis) < 100){
		if(abs(x_l-dis) < 100 && abs(x_r-dis) < 100){
			//motor_send_control_packet(fd1,v_l/2,Kp,Ki);
			//motor_send_control_packet(fd2,v_r/2,Kp,Ki);
			motor_send_control_packet(fd1,10*dir,Kp,Ki);
			motor_send_control_packet(fd2,10*dir,Kp,Ki);
			while(1){
				printf("recv start\n");
				motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
				motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
				//printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
				printf("end\n");		
				c_left=m_info_l.puls;
				c_right=m_info_r.puls;
				printf("puls\tl = %d, r = %d\n", c_left, c_right);
				x_l=(int)(c_left*t_par);
				x_r=(int)(c_right*t_par);
				printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);

				if(abs(x_l-dis) < 20 && abs(x_r-dis) < 20){
					motor_send_control_packet(fd1,0,Kp,Ki);
					motor_send_control_packet(fd2,0,Kp,Ki);
					break;
				}
				if(abs(x_l-dis) < 50 || abs(x_r-dis) < 50){
					//motor_send_control_packet(fd1,v_l/4,Kp,Ki);
					//motor_send_control_packet(fd2,v_r/4,Kp,Ki);
					motor_send_control_packet(fd1,12*dir,Kp,Ki);
					motor_send_control_packet(fd2,12*dir,Kp,Ki);
				}
				if(abs(x_l) > abs(dis)+20){
					//motor_send_control_packet(fd1,-v_l/4,Kp,Ki);
					motor_send_control_packet(fd1,-8*dir,Kp,Ki);
				}
				if(abs(x_r) > abs(dis)+20){
					//motor_send_control_packet(fd2,-v_r/4,Kp,Ki);
					motor_send_control_packet(fd2,-8*dir,Kp,Ki);
				}

				printf("roop end\n");
				usleep(130*1000);
			}
			break;
		}
		usleep(130*1000);
	}
	
	motor_stop();
	//return 0;
}

void motor_rotate(void *arg){
	int *cmd=(int*)arg;
	double angle = cmd[0]*PI/180;
	int dis = (int)(angle*MIRS_RADIUS);
	int time = cmd[1];
	int c_left, c_right;
	float speed_l, speed_r;
	int x_l, x_r;
	int dir=1; // dirction flag
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
	
	//speed_l = (int)(-100*dis/(t_par*time));
	//speed_r = (int)(100*dis/(t_par*time));
	speed_l = -100*dis/(t_par*time);
	speed_r = 100*dis/(t_par*time);

	v_l = (char)speed_l;
	v_r = (char)speed_r;
	printf("original vl = %d, vr = %d\n", v_l, v_r);

	if(abs(speed_l) > VLMAX){
		if(speed_l > 0){ 
			v_l = VLMAX; v_r = -VLMAX;
		}else{ 
			v_l = -VLMAX; v_r = VLMAX;
		}
	} else if(abs(speed_l)<VLMIN){
		if(speed_l > 0){ 
			v_l = VLMIN; v_r = -VLMIN;
		}else{ 
			v_l = -VLMIN; v_r = VLMIN;
		}
	}

	if(v_l>0){dir=-1;}
	/*
	if(abs(v_l)<15){
		v_l=-15*dir;
		v_r=-15*dir;
	}
	*/

	v_lm = v_l; v_rm = v_r;	

	dis=abs(dis);

	pthread_mutex_lock(&mutex_motor);
//	motor_send_start_packet (fd1);
//	motor_send_start_packet (fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	usleep(130000);
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);
	pthread_mutex_unlock(&mutex_motor);
	usleep(130*1000);
	c_left=0; c_right=0;
	v_lm=v_l; v_rm=v_r;

	printf("rotation distance [mm] = %d\n",dis);

	while(1){
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		//printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
		//printf("end\n");		
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		//printf("puls\tl = %d, r = %d\n", c_left, c_right);
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		//if(v_l <= 0 || v_r <= 0) break;

		if(abs(x_l+dis*dir) > 50 || abs(x_r-dis*dir) > 50){
			if((x_l + x_r) > 10){
				v_lm=v_l-3; v_rm=v_r-3;
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				printf("v_lm = %d, v_rm = %d \n", v_lm, v_rm);
			}else if((x_l + x_r) < -10){
				v_lm=v_l+3; v_rm=v_r+3;
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				printf("v_lm = %d, v_rm = %d \n", v_lm, v_rm);
			}else{
				v_lm=v_l;
				v_rm=v_r;
				motor_send_control_packet(fd1,v_l,Kp,Ki);
				motor_send_control_packet(fd2,v_r,Kp,Ki);
			}
			//printf("fist loop\n");
		}

		if(abs(x_l+dis*dir) < 50 && abs(x_r-dis*dir) < 50){
			//printf("second loop\n");
			//exit(0);
			motor_send_control_packet(fd1,-10*dir,Kp,Ki);
			motor_send_control_packet(fd2,10*dir,Kp,Ki);
			while(1){
	//			printf("recv start\n");
				motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
				motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
	//			printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
	//			printf("end\n");		
				c_left=m_info_l.puls;
				c_right=m_info_r.puls;
	//			printf("puls\tl = %d, r = %d\n", c_left, c_right);
				x_l=(int)(c_left*t_par);
				x_r=(int)(c_right*t_par);
				printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);

				if(abs(x_l+dis*dir) < 10 && abs(x_r-dis*dir) < 10){
					motor_send_control_packet(fd1,0,Kp,Ki);
					motor_send_control_packet(fd2,0,Kp,Ki);
					break;
				}

				if(abs(x_l+dis*dir) < 20 && abs(x_r-dis*dir) < 20){
					motor_send_control_packet(fd1,-8*dir,Kp,Ki);
					motor_send_control_packet(fd2,8*dir,Kp,Ki);
				}else if(abs(x_l+dis*dir) < 20 || abs(x_r-dis*dir) < 20){
					if(abs(x_l+dis*dir) < 20){
						motor_send_control_packet(fd1,-8*dir,Kp,Ki);
					}else{
						motor_send_control_packet(fd2,8*dir,Kp,Ki);
					}
				}

				if(abs(x_l) > abs(dis)+10 && abs(x_r) > abs(dis)+10){
					motor_send_control_packet(fd1,12*dir,Kp,Ki);
					motor_send_control_packet(fd2,-12*dir,Kp,Ki);
				} else if(abs(x_l) > abs(dis)+10 || abs(x_r) > abs(dis)+10 ){
					if(abs(x_l) > abs(dis) + 10){
						motor_send_control_packet(fd1,12*dir,Kp,Ki);
					}else{
						motor_send_control_packet(fd2,-12*dir,Kp,Ki);
					}
				}

	//			printf("roop end\n");
				usleep(130*1000);
			}
			break;
		}
		usleep(130*1000);

	}

	if(motor_send_control_packet(fd1,0,Kp,Ki) < 0){fprintf(stderr, "error");}
	if(motor_send_control_packet(fd2,0,Kp,Ki) < 0){fprintf(stderr, "error");}
/*
	usleep(130000);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
*/
	usleep(130000);
	motor_stop();
	//pthread_mutex_unlock(&mutex_motor);
	mtask_flag=1;

	//return 0;
}

void motor_circle(void *arg){
	int c_left,c_right;
	int *cmd=(int*)arg;
	int dis_l=0,dis_r=0;
	int time;
	float speed_l, speed_r;
	int x_l,x_r;
	int rot, radius,rot_dir;
	int dir=1;
	int x_lr, dist;
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
	printf("thread in\n");
	rot=cmd[0];
	time=cmd[1];
	radius=cmd[2];
	rot_dir=cmd[3];

	if(rot_dir==0){
		dis_l=rot*PI/180*(radius+MIRS_RADIUS);
		dis_r=rot*PI/180*(radius-MIRS_RADIUS);
	}
	if(rot_dir==1){
		dis_l=rot*PI/180*(radius-MIRS_RADIUS);
		dis_r=rot*PI/180*(radius+MIRS_RADIUS);
	}
	
	//speed_l=(int)(100*dis_l/(t_par*time));
	//speed_r=(int)(100*dis_r/(t_par*time));
	speed_l=100*dis_l/(t_par*time);
	speed_r=100*dis_r/(t_par*time);
	
	//v_l = (char)speed_l;
	//v_r = (char)speed_r;
	v_l = (int)speed_l;
	v_r = (int)speed_r;

	printf("original vl = %d, vr = %d\n", v_l, v_r);

	if(abs(speed_l) > VLMAX){
		if(speed_l > 0){ 
			v_l=VLMAX;
		}else{
			v_l=-VLMAX;
		}
	}
	if(abs(speed_r) > VLMAX){
		if(speed_r > 0){ 
			v_r=VLMAX;
		}else{
			v_r=-VLMAX;
		}
	}
	if(abs(speed_l) < VLMIN){
		if(speed_l > 0){ 
			v_r+=(VLMIN-v_l);
			v_l=VLMIN; 
		}else{
			v_r-=(VLMIN+v_l);
			v_l=-VLMIN;
		}
	}
	if(abs(speed_r) < VLMIN){
		if(speed_r > 0){ 
			v_l+=(VLMIN-v_r);
			v_r=VLMIN; 
		}else{
			v_l-=(VLMIN+v_r);
			v_r=-VLMIN;
		}
	}

	v_lm = v_l; v_rm = v_r;	

	if(v_l<0){dir=-1;}

	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	printf("send start\n");
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);

	usleep(130*1000);

	printf("end\n");
	c_left=0; c_right=0;
	while(1){
		//pthread_testcancel();
		printf("recv start\n");
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		//printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
		printf("end\n");		
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		printf("puls\tl = %d, r = %d\n", c_left, c_right);
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		//if(v_l <= 0 || v_r <= 0) break;

		x_lr=(x_l+x_r)/2;
		dist=(dis_l+dis_r)/2;

		if(abs(x_l-dis_l) > 100 || abs(x_r-dis_r) > 100){
		//if(abs(x_l-dis_l) > 70 || abs(x_r-dis_r) > 70){
			if(x_l- dis_l*x_lr/dist - x_r + dis_r*x_lr/dist > 10){
				v_lm=v_l-5; v_rm=v_r+5;
				//v_lm-=1; v_rm+=1;
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				printf("v_lm = %d, v_rm = %d \n", v_lm, v_rm);
			}else if(x_r -dis_r*x_lr/dist - x_l + dis_l*x_lr/dist > 10){
				v_lm=v_l+5; v_rm=v_r-5;
				//v_lm+=1; v_rm-=1;
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				printf("v_lm = %d, v_rm = %d \n", v_lm, v_rm);
			}else{
				motor_send_control_packet(fd1,v_l,Kp,Ki);
				motor_send_control_packet(fd2,v_r,Kp,Ki);
			}
		}

		//if(abs(x_l-dis_l) < 100 || abs(x_r-dis_r) < 100){
		if(abs(x_l-dis_l) < 100 && abs(x_r-dis_r) < 100){
		//if(abs(x_l-dis_l) < 70 && abs(x_r-dis_r) < 70){
			motor_send_control_packet(fd1,v_l/2,Kp,Ki);
			motor_send_control_packet(fd2,v_r/2,Kp,Ki);
			while(1){
				printf("recv start\n");
				motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
				motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
				//printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
				printf("end\n");		
				c_left=m_info_l.puls;
				c_right=m_info_r.puls;
				printf("puls\tl = %d, r = %d\n", c_left, c_right);
				x_l=(int)(c_left*t_par);
				x_r=(int)(c_right*t_par);
				printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);

				if(abs(x_l-dis_l) < 20 && abs(x_r-dis_r) < 20){
					motor_send_control_packet(fd1,0,Kp,Ki);
					motor_send_control_packet(fd2,0,Kp,Ki);
					break;
				}
				if(abs(x_l-dis_l) < 50 || abs(x_r-dis_r) < 50){
					motor_send_control_packet(fd1,12*dir,Kp,Ki);
					motor_send_control_packet(fd2,12*dir,Kp,Ki);
				}
				if(abs(x_l) > abs(dis_l)+20){
					motor_send_control_packet(fd1,-8*dir,Kp,Ki);
					motor_send_control_packet(fd2,0,Kp,Ki);
				}
				if(abs(x_r) > abs(dis_r)+20){
					motor_send_control_packet(fd1,0,Kp,Ki);
					motor_send_control_packet(fd2,-8*dir,Kp,Ki);
				}

				printf("roop end\n");
				usleep(130*1000);
			}
			break;
		}
		usleep(130*1000);
	}
	
/*
	motor_send_control_packet(fd1,0,Kp,Ki);
	motor_send_control_packet(fd2,0,Kp,Ki);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
*/
	motor_stop();
	//return 0;
}


