#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
#include <pthread.h>
//#include <sys/types.h>
//#include <sys/stat.h>
#include <fcntl.h>
#include "func_extern.h"
#include "mg3.h"
//#include "../main/control.h"
//#include "../main/pwm_enc.h"
#include "motor.h"

extern int fd1, fd2;
extern int motor_restart_flag;

extern int x_r_tmp,x_l_tmp;
extern int const_flag;
extern int r_ts_flag;
extern int l_ts_flag;
extern int r_ws_flag;
extern float sp_time;
extern int time_end_flag;
extern int timer_exit_flag;
extern int ts_exit_flag;

extern FILE *fp;

void *mk_right_turn(void *arg){
	
	int x_l=0;
	int x_r=0;
	int c_left, c_right;
	int dis,dir;
	int *cmd=(int*)arg;
	int end_time=0;
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;

	v_l=20; v_r=0;
	dis=cmd[0]-abs(x_l_tmp);
	dir=cmd[1];
	end_time=cmd[4];

	motor_send_start_packet (fd1);
	motor_send_stop_packet (fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);

	c_left=0; c_right=0;
	v_lm=v_l; v_rm=v_r;

	fprintf(fp,"mk_turn\n");
	fclose_open('f');
	while(1){

		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
	
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;

		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);

		fprintf(fp,"vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		fclose_open('f');

		if(motor_send_control_packet(fd1,v_lm*dir,Kp,Ki) < 0) motor_restart_flag=1;
		if(abs(dis)<abs(x_l)){
			const_flag=1;
			break;
		}
		if(end_time!=0){
			if((int)sp_time > end_time)time_end_flag=1;
			if(time_end_flag==1)break;
		}
		if(motor_restart_flag==1)break;
		if(r_ts_flag==1)break;
		if(l_ts_flag==1)break;
		if(r_ws_flag==1)break;
		usleep(13000);
	}
	if(motor_send_control_packet(fd1,0,Kp,Ki) < 0){fprintf(stderr, "error");}
	if(motor_send_control_packet(fd2,0,Kp,Ki) < 0){fprintf(stderr, "error");}

	x_r_tmp=x_r;
	x_l_tmp=x_l;
	if(time_end_flag==1)const_flag=1;
	if(const_flag==1){
		x_r_tmp=0;
		x_l_tmp=0;
	}
	//motor_stop_thread();
	motor_stop_thread();
	ts_exit_flag=1;
	timer_exit_flag=1;
	pthread_exit(0);
	return 0;
}
void *mk_left_turn(void *arg){
	int x_l=0;
	int x_r=0;
	int c_left, c_right;
	int dis,dir,end_time=0;
	int *cmd=(int*)arg;
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;

	v_l=0; v_r=20;
	dis=cmd[0]-abs(x_r_tmp);
	dir=cmd[1];
	end_time=cmd[4];
	motor_send_stop_packet (fd1);
	motor_send_start_packet (fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	c_left=0; c_right=0;
	v_lm=v_l; v_rm=v_r;

	fprintf(fp,"mk_turn\n");
	fclose_open('f');

	while(1){

		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
	
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;

		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);

		fprintf(fp,"vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		fclose_open('f');

		if(motor_send_control_packet(fd2,v_rm*dir,Kp,Ki) < 0) motor_restart_flag=1;
		if(abs(dis)<abs(x_r)){
			const_flag=1;
			break;
		}
		if(end_time!=0){
			if((int)sp_time > end_time)time_end_flag=1;
			if(time_end_flag==1)break;
		}
		if(motor_restart_flag==1)break;
		if(r_ts_flag==1)break;
		if(l_ts_flag==1)break;
		if(r_ws_flag==1)break;
		usleep(13000);
	}
	if(motor_send_control_packet(fd1,0,Kp,Ki) < 0){fprintf(stderr, "error");}
	if(motor_send_control_packet(fd2,0,Kp,Ki) < 0){fprintf(stderr, "error");}
	motor_send_stop_packet (fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	x_r_tmp=x_r;
	x_l_tmp=x_l;
	if(time_end_flag==1)const_flag=1;
	if(const_flag==1){
		x_r_tmp=0;
		x_l_tmp=0;
	}
	motor_stop_thread();
	//usleep(130*1000);
	ts_exit_flag=1;
	timer_exit_flag=1;
	pthread_exit(0);
	return 0;
}

