/*
 * original_motor_thread.c
 *
 *  Created on: 2012/12/14
 *      Author: d09101
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
#include <time.h>
#include <pthread.h>
#include <errno.h>
//#include <sys/types.h>
//#include <sys/stat.h>
#include <fcntl.h>
#include "func_extern.h"
#include "mg3.h"
//#include "../main/control.h"
#include "motor.h"
#include "../original/original.h"


extern int r_uss_wall_flag;
extern int l_uss_wall_flag;
extern int uss_pid;
extern int uss_use;
int uss_exit_flag;

extern int f_ts_flag;
extern int r_ts_flag;
extern int l_ts_flag;
extern int r_ws_flag;
int ts_exit_flag;

extern float sp_time;
extern int time_end_flag;
int timer_exit_flag;

int motor_restart_flag;

int x_r_tmp=0,x_l_tmp=0,x_r_tmp_keep,x_l_tmp_keep;
int const_flag;

extern int kobeya_exit_flag;

extern int fd1, fd2;

extern FILE *fp;

int motor_stop_thread(){
	pthread_mutex_lock(&mutex_motor);
	motor_send_stop_packet (fd1);
	motor_send_stop_packet (fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	pthread_mutex_unlock(&mutex_motor);

	return 0;
}

void *original_straight_thread(void *arg){
	int c_left,c_right;
	int *cmd=(int*)arg;
	float speed_l, speed_r;
	int x_l,x_r;
	int dir=1;
	char v_l, v_r, v_lm, v_rm;
	int pre_speed=0;
	int end_time=0;
	MotorInfo m_info_l, m_info_r;
	printf("motor thread in\n");
	fprintf(fp,"straight_thread\n");
	fclose_open('f');
	pre_speed=cmd[0];
	end_time=cmd[4];
	fprintf(fp,"end_time = %d\n",end_time);
	fclose_open('f');
	motor_restart_flag=0;
	uss_pid=0;

	speed_l=pre_speed;
	speed_r=pre_speed;

	v_l = (int)speed_l;
	v_r = (int)speed_r;
	//v_l = (char)speed_l;
	//v_r = (char)speed_r;

	fprintf(fp,"original vl = %d, vr = %d\n", v_l, v_r);
	fclose_open('f');

	if(abs(speed_l) > VLMAX){
		if(speed_l > 0){ v_l=VLMAX; v_r=VLMAX; }
		else{ v_l = -VLMAX; v_r = -VLMAX; }
	}else if(abs(speed_l) < VLMIN){
		if(speed_l > 0){ v_l=VLMIN; v_r=VLMIN; }
		else{ v_l = -VLMIN; v_r = -VLMIN; }
	}

	v_lm = v_l; v_rm = v_r;

	if(v_l<0){dir=-1;}

	pthread_mutex_lock(&mutex_motor);
	motor_send_start_packet (fd1);
	motor_send_start_packet (fd2);
	pthread_mutex_unlock(&mutex_motor);
	pthread_mutex_trylock(&mutex_motor);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	fprintf(fp,"send start\n");
	fclose_open('f');
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);
	pthread_mutex_unlock(&mutex_motor);

	usleep(130*1000);

	fprintf(fp,"end\n");
	fclose_open('f');
	c_left=0; c_right=0;
	while(1){
		//pthread_testcancel();

		fprintf(fp,"recv start\n");
		fclose_open('f');
		if(end_time!=0){
			if((int)sp_time > end_time)time_end_flag=1;
			if(time_end_flag==1)break;
		}
		if(r_uss_wall_flag==0)break;
		if(l_uss_wall_flag==0)break;
		if(f_ts_flag==1)break;
		if(l_ts_flag==1)break;
		if(r_ts_flag==1)break;
		if(r_ws_flag==1)break;
		if(motor_restart_flag==1)break;
		if(kobeya_exit_flag==1)break;

		pthread_mutex_lock(&mutex_motor);
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		pthread_mutex_unlock(&mutex_motor);

		//printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
		fprintf(fp,"end\n");
		fclose_open('f');
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		fprintf(fp,"puls\tl = %d, r = %d\n", c_left, c_right);
		fclose_open('f');
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		fprintf(fp,"vl = %d, vr = %d, xl = %d, xr = %d\nuss_pid = %d\n", v_l, v_r, x_l, x_r, uss_pid);
		fclose_open('f');
		//if(v_l <= 0 || v_r <= 0) break;

		if(uss_use==10||uss_use==1){
			v_lm=v_l-uss_pid; v_rm=v_r+uss_pid;
			pthread_mutex_lock(&mutex_motor);
			if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
			if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
			pthread_mutex_unlock(&mutex_motor);
		}else{
			if(x_l - x_r > 10){
				v_lm=v_l-5-uss_pid; v_rm=v_r+5+uss_pid;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
			}else if(x_r - x_l > 10){
				v_lm=v_l+5-uss_pid; v_rm=v_r-5+uss_pid;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
			}else{
				v_lm=v_l; v_rm=v_r;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_l,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_r,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
			}
		}

		if(end_time!=0){
			if((int)sp_time > end_time)time_end_flag=1;
			if(time_end_flag==1)break;
		}
		if(r_uss_wall_flag==0)break;
		if(l_uss_wall_flag==0)break;
		if(f_ts_flag==1)break;
		if(l_ts_flag==1)break;
		if(r_ts_flag==1)break;
		if(r_ws_flag==1)break;
		if(motor_restart_flag==1)break;
		if(kobeya_exit_flag==1)break;
		usleep(MOTOR_PERIOD);
	}
	motor_stop_thread();
	usleep(130*1000);
	printf("motor thread exit\n");
	fprintf(fp,"r_uss_wall_flag = %d\nl_uss_wall_flag = %d\n",r_uss_wall_flag,l_uss_wall_flag);
	fprintf(fp,"f_ts_flag = %d\nl_ts_flag = %d\nr_ts_flag = %d\n",f_ts_flag,l_ts_flag,r_ts_flag);
	fprintf(fp,"time_end_flag = %d\nr_ws_flag = %d\n",time_end_flag,r_ws_flag);
	fprintf(fp,"motor_restart_flag = %d\n",motor_restart_flag);
	fclose_open('f');
	mtask_flag=1;
	uss_exit_flag=1;
	ts_exit_flag=1;
	timer_exit_flag=1;
	pthread_exit(0);
	return 0;
}

void *const_straight_thread(void *arg){
	int c_left,c_right;
	int *cmd=(int*)arg;
	int dis,speed,end_time;
	float speed_l, speed_r;
	int x_l,x_r;
	int dir=1;
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
	printf("motor thread in\n");
	fprintf(fp,"straight_thread\n");
	dis=cmd[0];
	speed=cmd[1];
	end_time=cmd[4];

	speed_l=speed;//100*dis/(t_par*time);
	speed_r=speed;//100*dis/(t_par*time);

	dis=dis-(x_r_tmp+x_l_tmp)/2;

	v_l = (int)speed_l;
	v_r = (int)speed_r;

	fprintf(fp,"original vl = %d, vr = %d\n", v_l, v_r);
	fclose_open('f');

	if(abs(speed_l) > VLMAX){
		if(speed_l > 0){ v_l=VLMAX; v_r=VLMAX; }
		else{ v_l = -VLMAX; v_r = -VLMAX; }
	}else if(abs(speed_l) < VLMIN){
		if(speed_l > 0){ v_l=VLMIN; v_r=VLMIN; }
		else{ v_l = -VLMIN; v_r = -VLMIN; }
	}

	v_lm = v_l; v_rm = v_r;

	if(v_l<0){dir=-1;}

	pthread_mutex_lock(&mutex_motor);
	motor_send_start_packet (fd1);
	motor_send_start_packet (fd2);
	pthread_mutex_unlock(&mutex_motor);

 	pthread_mutex_lock(&mutex_motor);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	fprintf(fp,"send start\n");
	fclose_open('f');
	//usleep(130000);
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);
	pthread_mutex_unlock(&mutex_motor);
	//usleep(130000);

	usleep(130*1000);

	fprintf(fp,"end\n");
	fclose_open('f');
	c_left=0; c_right=0;
	while(1){
		//pthread_testcancel();

		//fprintf(fp,"recv start\n");
		//fclose_open('f');
		/*
		if(abs(x_r) - abs(x_r_tmp) > v_rm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(abs(x_l) - abs(x_l_tmp) > v_lm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		
		if(v_l > 0 && x_l < -20)motor_restart_flag=1;
		if(v_l < 0 && x_l > 20)motor_restart_flag=1;
		if(v_r > 0 && x_r < -20)motor_restart_flag=1;
		if(v_r < 0 && x_r > 20)motor_restart_flag=1;
		*/
		if(end_time!=0){
			if((int)sp_time > end_time)time_end_flag=1;
			if(time_end_flag==1)break;
		}
		if(f_ts_flag==1)break;
		if(l_ts_flag==1)break;
		if(r_ts_flag==1)break;
		if(r_ws_flag==1)break;
		if(motor_restart_flag==1)break;

		pthread_mutex_lock(&mutex_motor);
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		pthread_mutex_unlock(&mutex_motor);

		//fprintf(fp,"end\n");
		//fclose_open('f');
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		fprintf(fp,"puls\tl = %d, r = %d\n", c_left, c_right);
		fclose_open('f');
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		if(abs(x_l) > 1000 && abs(x_r) < abs(dis))x_l=x_r;
		if(abs(x_r) > 1000 && abs(x_l) < abs(dis))x_r=x_l;
		fprintf(fp,"vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		fclose_open('f');

		if(abs(x_l-dis) > 100 || abs(x_r-dis) > 100){
			if(abs(dis) - abs(x_l) > 100 || abs(dis) - abs(x_r) > 100){
				if(x_l - x_r > 10){
					v_lm=v_l-5; v_rm=v_r+5;
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}else if(x_r - x_l > 10){
					v_lm=v_l+5; v_rm=v_r-5;
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}else{
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,v_l,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,v_r,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}
			}
			if(abs(dis) - abs(x_l) < -100 || abs(dis) - abs(x_r) < -100){
				if(x_l - x_r > 10){
					v_lm=-v_l-5; v_rm=-v_r+5;
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}else if(x_r - x_l > 10){
					v_lm=-v_l+5; v_rm=-v_r-5;
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}else{
					v_lm=-v_l;v_rm=-v_r;
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}
			}
		}

		//if(abs(x_l-dis) < 100 || abs(x_r-dis) < 100){
		if(abs(x_l-dis) < 100 && abs(x_r-dis) < 100){
			//motor_send_control_packet(fd1,v_l/2,Kp,Ki);
			//motor_send_control_packet(fd2,v_r/2,Kp,Ki);
			pthread_mutex_lock(&mutex_motor);
			if(motor_send_control_packet(fd1,10*dir,Kp,Ki) < 0) motor_restart_flag=1;
			if(motor_send_control_packet(fd2,10*dir,Kp,Ki) < 0) motor_restart_flag=1;
			pthread_mutex_unlock(&mutex_motor);
			while(1){
				//fprintf(fp,"recv start\n");
				/*
				if(abs(x_r) - abs(x_r_tmp) > v_rm*10){
					fprintf(fp,"/////speed over!!/////\n");
					fclose_open('f');
					motor_restart_flag=1;
				}
				if(abs(x_l) - abs(x_l_tmp) > v_lm*10){
					fprintf(fp,"/////speed over!!/////\n");
					fclose_open('f');
					motor_restart_flag=1;
				}
				
				if(v_l > 0 && x_l < -20)motor_restart_flag=1;
				if(v_l < 0 && x_l > 20)motor_restart_flag=1;
				if(v_r > 0 && x_r < -20)motor_restart_flag=1;
				if(v_r < 0 && x_r > 20)motor_restart_flag=1;
				*/
				if(end_time!=0){
					if((int)sp_time > end_time)time_end_flag=1;
					if(time_end_flag==1)break;
				}
				if(f_ts_flag==1)break;
				if(l_ts_flag==1)break;
				if(r_ts_flag==1)break;
				if(r_ws_flag==1)break;
				if(motor_restart_flag==1)break;

				pthread_mutex_lock(&mutex_motor);
				motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
				motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
				pthread_mutex_unlock(&mutex_motor);
				//printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
				//fprintf(fp,"end\n");
				//fclose_open('f');
				c_left=m_info_l.puls;
				c_right=m_info_r.puls;
				fprintf(fp,"puls\tl = %d, r = %d\n", c_left, c_right);
				fclose_open('f');
				x_l=(int)(c_left*t_par);
				x_r=(int)(c_right*t_par);
				if(abs(x_l) > 1000 && abs(x_r) < abs(dis))x_l=x_r;
				if(abs(x_r) > 1000 && abs(x_l) < abs(dis))x_r=x_l;
				fprintf(fp,"vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
				fclose_open('f');

				if(abs(x_l-dis) < 20 && abs(x_r-dis) < 20){
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,0,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,0,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
					const_flag=1;
					break;
				}
				if(abs(dis) - abs(x_l) < 50 && abs(dis) - abs(x_l) > 0){
					pthread_mutex_lock(&mutex_motor);
					//motor_send_control_packet(fd1,v_l/4,Kp,Ki);
					//motor_send_control_packet(fd2,v_r/4,Kp,Ki);
					if(motor_send_control_packet(fd1,12*dir,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,12*dir,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}
				if(abs(dis) - abs(x_r) < 50 && abs(dis) - abs(x_r) > 0){
					pthread_mutex_lock(&mutex_motor);
					//motor_send_control_packet(fd1,v_l/4,Kp,Ki);
					//motor_send_control_packet(fd2,v_r/4,Kp,Ki);
					if(motor_send_control_packet(fd1,12*dir,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,12*dir,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}
				if(abs(x_l) > abs(dis)+20){
					pthread_mutex_lock(&mutex_motor);
					//motor_send_control_packet(fd1,-v_l/4,Kp,Ki);
					if(motor_send_control_packet(fd1,-8*dir,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}
				if(abs(x_r) > abs(dis)+20){
					pthread_mutex_lock(&mutex_motor);
					//motor_send_control_packet(fd2,-v_r/4,Kp,Ki);
					if(motor_send_control_packet(fd2,-8*dir,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}

				//fprintf(fp,"roop end\n");
				//fclose_open('f');
				usleep(MOTOR_PERIOD);
				x_r_tmp=x_r;
				x_l_tmp=x_l;
			}
			break;
		}
		/*
		if(abs(x_r) - abs(x_r_tmp) > v_rm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(abs(x_l) - abs(x_l_tmp) > v_lm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(v_l > 0 && x_l < -20)motor_restart_flag=1;
		if(v_l < 0 && x_l > 20)motor_restart_flag=1;
		if(v_r > 0 && x_r < -20)motor_restart_flag=1;
		if(v_r < 0 && x_r > 20)motor_restart_flag=1;
		*/
		if(end_time!=0){
			if((int)sp_time > end_time)time_end_flag=1;
			if(time_end_flag==1)break;
		}
		if(f_ts_flag==1)break;
		if(l_ts_flag==1)break;
		if(r_ts_flag==1)break;
		if(r_ws_flag==1)break;
		if(motor_restart_flag==1)break;
		usleep(MOTOR_PERIOD);
		x_r_tmp=x_r;
		x_l_tmp=x_l;
	}
	motor_stop_thread();
	usleep(130*1000);
	printf("motor thread exit\n");
	fprintf(fp,"r_uss_wall_flag = %d\nl_uss_wall_flag = %d\n",r_uss_wall_flag,l_uss_wall_flag);
	fprintf(fp,"f_ts_flag = %d\nl_ts_flag = %d\nr_ts_flag = %d\n",f_ts_flag,l_ts_flag,r_ts_flag);
	fprintf(fp,"time_end_flag = %d\nr_ws_flag = %d\n",time_end_flag,r_ws_flag);
	fprintf(fp,"motor_restart_flag = %d\nconst_flag = %d\n",motor_restart_flag,const_flag);
	fclose_open('f');
	x_r_tmp=x_r;
	x_l_tmp=x_l;
	if(time_end_flag==1)const_flag=1;
	if(const_flag==1){
		x_r_tmp=0;
		x_l_tmp=0;
	}
	mtask_flag=1;
	uss_exit_flag=1;
	ts_exit_flag=1;
	timer_exit_flag=1;
	pthread_exit(0);

	return 0;
}


void *e_const_straight_thread(void *arg){
	int c_left,c_right;
	int *cmd=(int*)arg;
	int dis,speed,end_time;
	float speed_l, speed_r;
	int x_l,x_r;
	int dir=1;
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
	printf("motor thread in\n");
	fprintf(fp,"straight_thread\n");
	dis=cmd[0];
	speed=cmd[1];
	end_time=cmd[4];

	speed_l=speed;//100*dis/(t_par*time);
	speed_r=speed;//100*dis/(t_par*time);

	dis=dis-(x_r_tmp+x_l_tmp)/2;

	v_l = (int)speed_l;
	v_r = (int)speed_r;

	fprintf(fp,"original vl = %d, vr = %d\n", v_l, v_r);
	fclose_open('f');

	if(abs(speed_l) > VLMAX){
		if(speed_l > 0){ v_l=VLMAX; v_r=VLMAX; }
		else{ v_l = -VLMAX; v_r = -VLMAX; }
	}else if(abs(speed_l) < VLMIN){
		if(speed_l > 0){ v_l=VLMIN; v_r=VLMIN; }
		else{ v_l = -VLMIN; v_r = -VLMIN; }
	}

	v_lm = v_l; v_rm = v_r;

	if(v_l<0){dir=-1;}

	pthread_mutex_lock(&mutex_motor);
	motor_send_start_packet (fd1);
	motor_send_start_packet (fd2);
	pthread_mutex_unlock(&mutex_motor);

 	pthread_mutex_lock(&mutex_motor);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	fprintf(fp,"send start\n");
	fclose_open('f');
	//usleep(130000);
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);
	pthread_mutex_unlock(&mutex_motor);
	//usleep(130000);

	usleep(130*1000);

	fprintf(fp,"end\n");
	fclose_open('f');
	c_left=0; c_right=0;
	while(1){
		//pthread_testcancel();

		//fprintf(fp,"recv start\n");
		//fclose_open('f');
		/*
		if(abs(x_r) - abs(x_r_tmp) > v_rm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(abs(x_l) - abs(x_l_tmp) > v_lm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}

		if(v_l > 0 && x_l < -20)motor_restart_flag=1;
		if(v_l < 0 && x_l > 20)motor_restart_flag=1;
		if(v_r > 0 && x_r < -20)motor_restart_flag=1;
		if(v_r < 0 && x_r > 20)motor_restart_flag=1;
		*/
		if(end_time!=0){
			if((int)sp_time > end_time)time_end_flag=1;
			if(time_end_flag==1)break;
		}
		if(f_ts_flag==1)break;
		if(l_ts_flag==1)break;
		if(r_ts_flag==1)break;
		if(r_ws_flag==1)break;
		if(motor_restart_flag==1)break;

		pthread_mutex_lock(&mutex_motor);
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		pthread_mutex_unlock(&mutex_motor);

		//fprintf(fp,"end\n");
		//fclose_open('f');
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		fprintf(fp,"puls\tl = %d, r = %d\n", c_left, c_right);
		fclose_open('f');
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		if(abs(x_l) > 1000 && abs(x_r) < abs(dis))x_l=x_r;
		if(abs(x_r) > 1000 && abs(x_l) < abs(dis))x_r=x_l;
		fprintf(fp,"vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		fclose_open('f');


		if(abs(dis) - abs(x_l) > 20 && abs(dis) - abs(x_r) > 20){
			if(x_l - x_r > 10){
				v_lm=v_l-5; v_rm=v_r+5;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
			}else if(x_r - x_l > 10){
				v_lm=v_l+5; v_rm=v_r-5;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
			}else{
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_l,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_r,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
			}
		}
		if(abs(dis) - abs(x_l) < -20 && abs(dis) - abs(x_r) < -20){
			if(x_l - x_r > 10){
				v_lm=-v_l-5; v_rm=-v_r+5;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
			}else if(x_r - x_l > 10){
				v_lm=-v_l+5; v_rm=-v_r-5;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
			}else{
				v_lm=-v_l;v_rm=-v_r;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
			}
		}


		if(abs(x_l-dis) < 20 || abs(x_r-dis) < 20){
			pthread_mutex_lock(&mutex_motor);
			if(motor_send_control_packet(fd1,0,Kp,Ki) < 0) motor_restart_flag=1;
			if(motor_send_control_packet(fd2,0,Kp,Ki) < 0) motor_restart_flag=1;
			pthread_mutex_unlock(&mutex_motor);
			const_flag=1;
			break;
		}

		usleep(MOTOR_PERIOD);
		x_r_tmp=x_r;
		x_l_tmp=x_l;

		/*
		if(abs(x_r) - abs(x_r_tmp) > v_rm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(abs(x_l) - abs(x_l_tmp) > v_lm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(v_l > 0 && x_l < -20)motor_restart_flag=1;
		if(v_l < 0 && x_l > 20)motor_restart_flag=1;
		if(v_r > 0 && x_r < -20)motor_restart_flag=1;
		if(v_r < 0 && x_r > 20)motor_restart_flag=1;
		*/
		if(end_time!=0){
			if((int)sp_time > end_time)time_end_flag=1;
			if(time_end_flag==1)break;
		}
		if(f_ts_flag==1)break;
		if(l_ts_flag==1)break;
		if(r_ts_flag==1)break;
		if(r_ws_flag==1)break;
		if(motor_restart_flag==1)break;
		usleep(MOTOR_PERIOD);
		x_r_tmp=x_r;
		x_l_tmp=x_l;
	}
	motor_stop_thread();
	usleep(130*1000);
	printf("motor thread exit\n");
	fprintf(fp,"r_uss_wall_flag = %d\nl_uss_wall_flag = %d\n",r_uss_wall_flag,l_uss_wall_flag);
	fprintf(fp,"f_ts_flag = %d\nl_ts_flag = %d\nr_ts_flag = %d\n",f_ts_flag,l_ts_flag,r_ts_flag);
	fprintf(fp,"time_end_flag = %d\nr_ws_flag = %d\n",time_end_flag,r_ws_flag);
	fprintf(fp,"motor_restart_flag = %d\nconst_flag = %d\n",motor_restart_flag,const_flag);
	fclose_open('f');
	x_r_tmp=x_r;
	x_l_tmp=x_l;
	if(time_end_flag==1)const_flag=1;
	if(const_flag==1){
		x_r_tmp=0;
		x_l_tmp=0;
	}
	mtask_flag=1;
	uss_exit_flag=1;
	ts_exit_flag=1;
	timer_exit_flag=1;
	pthread_exit(0);

	return 0;
}

//void motor_rotate(void *arg){
void *const_rotate_thread(void *arg){
	int *cmd=(int*)arg;
	double angle = cmd[0]*PI/180;
	int dis = (int)(angle*MIRS_RADIUS);
	int speed = cmd[1];
	int end_time = cmd[4];
	int c_left, c_right;
	float speed_l, speed_r;
	int x_l, x_r;
	int dir=1; // dirction flag
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;

	printf("motor thread in\n");
	fprintf(fp,"rotate_thread\n");
	fclose_open('f');
	speed_l = -speed;
	speed_r = speed;

	v_l = (char)speed_l;
	v_r = (char)speed_r;
	fprintf(fp,"original vl = %d, vr = %d\n", v_l, v_r);
	fclose_open('f');

	if(abs(speed_l) > VLMAX){
		if(speed_l > 0){
			v_l = VLMAX; v_r = -VLMAX;
		}else{
			v_l = -VLMAX; v_r = VLMAX;
		}
	} else if(abs(speed_l)<VLMIN){
		if(speed_l > 0){
			v_l = VLMIN; v_r = -VLMIN;
		}else{
			v_l = -VLMIN; v_r = VLMIN;
		}
	}

	if(v_l>0){dir=-1;}

	v_lm = v_l; v_rm = v_r;

	dis=abs(dis)-(x_r_tmp-x_l_tmp)/2;

	pthread_mutex_lock(&mutex_motor);
	motor_send_start_packet (fd1);
	motor_send_start_packet (fd2);
	pthread_mutex_unlock(&mutex_motor);
	pthread_mutex_lock(&mutex_motor);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	//usleep(130000);
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);
	pthread_mutex_unlock(&mutex_motor);
	usleep(MOTOR_PERIOD);
	c_left=0; c_right=0;
	v_lm=v_l; v_rm=v_r;

	fprintf(fp,"rotation distance [mm] = %d\n",dis);
	fclose_open('f');

	while(1){
		/*
		if(abs(x_r) - abs(x_r_tmp) > v_rm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(abs(x_l) - abs(x_l_tmp) > v_lm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(v_l > 0 && x_l < -20)motor_restart_flag=1;
		if(v_l < 0 && x_l > 20)motor_restart_flag=1;
		if(v_r > 0 && x_r < -20)motor_restart_flag=1;
		if(v_r < 0 && x_r > 20)motor_restart_flag=1;
		*/
		if(end_time!=0){
			if((int)sp_time > end_time)time_end_flag=1;
			if(time_end_flag==1)break;
		}
		if(f_ts_flag==1)break;
		if(l_ts_flag==1)break;
		if(r_ts_flag==1)break;
		if(r_ws_flag==1)break;
		if(motor_restart_flag==1)break;

		pthread_mutex_lock(&mutex_motor);
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		pthread_mutex_unlock(&mutex_motor);
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		if(abs(x_l) > 1000 && abs(x_r) < abs(dis))x_l=-x_r;
		if(abs(x_r) > 1000 && abs(x_l) < abs(dis))x_r=-x_l;
		fprintf(fp,"vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		fclose_open('f');

		if(abs(x_l+dis*dir) > 50 || abs(x_r-dis*dir) > 50){
			if(abs(dis)-abs(x_l) > 50|| abs(dis)-abs(x_r) > 50){
				if((x_l + x_r) > 10){
					v_lm=v_l-3; v_rm=v_r-3;
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
					fprintf(fp,"v_lm = %d, v_rm = %d \n", v_lm, v_rm);
					fclose_open('f');
				}else if((x_l + x_r) < -10){
					v_lm=v_l+3; v_rm=v_r+3;
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
					fprintf(fp,"v_lm = %d, v_rm = %d \n", v_lm, v_rm);
					fclose_open('f');
				}else{
					v_lm=v_l;
					v_rm=v_r;
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,v_l,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,v_r,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}
			}
			if(abs(dis)-abs(x_l) < -50|| abs(dis)-abs(x_r) < -50){
				if((x_l + x_r) > 10){
					v_lm=-v_l-3; v_rm=-v_r-3;
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
					fprintf(fp,"v_lm = %d, v_rm = %d \n", v_lm, v_rm);
					fclose_open('f');
				}else if((x_l + x_r) < -10){
					v_lm=-v_l+3; v_rm=-v_r+3;
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
					fprintf(fp,"v_lm = %d, v_rm = %d \n", v_lm, v_rm);
					fclose_open('f');
				}else{
					v_lm=-v_l;
					v_rm=-v_r;
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,v_l,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,v_r,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}
			}

		}

		if(abs(x_l+dis*dir) < 50 && abs(x_r-dis*dir) < 50){
			pthread_mutex_lock(&mutex_motor);
			if(motor_send_control_packet(fd1,-10*dir,Kp,Ki) < 0) motor_restart_flag=1;
			if(motor_send_control_packet(fd2,10*dir,Kp,Ki) < 0) motor_restart_flag=1;
			pthread_mutex_unlock(&mutex_motor);
			while(1){
				/*
				if(abs(x_r) - abs(x_r_tmp) > v_rm*10){
					fprintf(fp,"/////speed over!!/////\n");
					fclose_open('f');
					motor_restart_flag=1;
				}
				if(abs(x_l) - abs(x_l_tmp) > v_lm*10){
					fprintf(fp,"/////speed over!!/////\n");
					fclose_open('f');
					motor_restart_flag=1;
				}
				if(v_l > 0 && x_l < -20)motor_restart_flag=1;
				if(v_l < 0 && x_l > 20)motor_restart_flag=1;
				if(v_r > 0 && x_r < -20)motor_restart_flag=1;
				if(v_r < 0 && x_r > 20)motor_restart_flag=1;
				*/
				if(end_time!=0){
					if((int)sp_time > end_time)time_end_flag=1;
					if(time_end_flag==1)break;
				}
				if(f_ts_flag==1)break;
				if(l_ts_flag==1)break;
				if(r_ts_flag==1)break;
				if(r_ws_flag==1)break;
				if(motor_restart_flag==1)break;

				pthread_mutex_lock(&mutex_motor);
				motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
				motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
				pthread_mutex_unlock(&mutex_motor);
				c_left=m_info_l.puls;
				c_right=m_info_r.puls;
				x_l=(int)(c_left*t_par);
				x_r=(int)(c_right*t_par);
				if(abs(x_l) > 1000 && abs(x_r) < abs(dis))x_l=-x_r;
				if(abs(x_r) > 1000 && abs(x_l) < abs(dis))x_r=-x_l;
				fprintf(fp,"vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
				fclose_open('f');

				if(abs(x_l+dis*dir) < 15 && abs(x_r-dis*dir) < 15){
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,0,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,0,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
					const_flag=1;
					break;
				}

				if(abs(dis) - abs(x_l) < 20 && abs(dis) - abs(x_l) > 0 && abs(dis) - abs(x_r) < 20 && abs(dis) - abs(x_r) > 0){
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,-8*dir,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,8*dir,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}else if(abs(dis) - abs(x_l) < 20 && abs(dis) - abs(x_l) > 0){
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,-8*dir,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}else if(abs(dis) - abs(x_r) < 20 && abs(dis) - abs(x_r) > 0){
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd2,8*dir,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				}

				if(abs(x_l) > abs(dis)+15 && abs(x_r) > abs(dis)+15){
					pthread_mutex_lock(&mutex_motor);
					if(motor_send_control_packet(fd1,12*dir,Kp,Ki) < 0) motor_restart_flag=1;
					if(motor_send_control_packet(fd2,-12*dir,Kp,Ki) < 0) motor_restart_flag=1;
					pthread_mutex_unlock(&mutex_motor);
				} else if(abs(x_l) > abs(dis)+15 || abs(x_r) > abs(dis)+15 ){
					if(abs(x_l) > abs(dis) + 15){
						pthread_mutex_lock(&mutex_motor);
						if(motor_send_control_packet(fd1,12*dir,Kp,Ki) < 0) motor_restart_flag=1;
						pthread_mutex_unlock(&mutex_motor);
					}else{
						pthread_mutex_lock(&mutex_motor);
						if(motor_send_control_packet(fd2,-12*dir,Kp,Ki) < 0) motor_restart_flag=1;
						pthread_mutex_unlock(&mutex_motor);
					}
				}

	//			printf("roop end\n");
				usleep(MOTOR_PERIOD);
				x_r_tmp=x_r;
				x_l_tmp=x_l;
			}
			break;
		}
		/*
		if(abs(x_r) - abs(x_r_tmp) > v_rm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(abs(x_l) - abs(x_l_tmp) > v_lm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(v_l > 0 && x_l < 0)motor_restart_flag=1;
		if(v_l < 0 && x_l > 0)motor_restart_flag=1;
		if(v_r > 0 && x_r < 0)motor_restart_flag=1;
		if(v_r < 0 && x_r > 0)motor_restart_flag=1;
		*/
		if(end_time!=0){
			if((int)sp_time > end_time)time_end_flag=1;
			if(time_end_flag==1)break;
		}
		if(f_ts_flag==1)break;
		if(l_ts_flag==1)break;
		if(r_ts_flag==1)break;
		if(r_ws_flag==1)break;
		if(motor_restart_flag==1)break;
		usleep(MOTOR_PERIOD);
		x_r_tmp=x_r;
		x_l_tmp=x_l;

	}

	pthread_mutex_lock(&mutex_motor);
	if(motor_send_control_packet(fd1,0,Kp,Ki) < 0){
		fprintf(stderr, "error");
		motor_restart_flag=1;
	}
	if(motor_send_control_packet(fd2,0,Kp,Ki) < 0){
		fprintf(stderr, "error");
		motor_restart_flag=1;
	}
	pthread_mutex_unlock(&mutex_motor);

	usleep(MOTOR_PERIOD);
	motor_stop_thread();
	usleep(130*1000);
	printf("motor thread exit\n");
	fprintf(fp,"r_uss_wall_flag = %d\nl_uss_wall_flag = %d\n",r_uss_wall_flag,l_uss_wall_flag);
	fprintf(fp,"f_ts_flag = %d\nl_ts_flag = %d\nr_ts_flag = %d\n",f_ts_flag,l_ts_flag,r_ts_flag);
	fprintf(fp,"time_end_flag = %d\nr_ws_flag = %d\n",time_end_flag,r_ws_flag);
	fprintf(fp,"motor_restart_flag = %d\nconst_flag = %d\n",motor_restart_flag,const_flag);
	fclose_open('f');
	x_r_tmp=x_r;
	x_l_tmp=x_l;
	if(time_end_flag==1)const_flag=1;
	if(const_flag==1){
		x_r_tmp=0;
		x_l_tmp=0;
	}
	mtask_flag=1;
	uss_exit_flag=1;
	ts_exit_flag=1;
	timer_exit_flag=1;
	pthread_exit(0);
	return 0;
}

void *e_const_rotate_thread(void *arg){
	int *cmd=(int*)arg;
	double angle = cmd[0]*PI/180;
	int dis = (int)(angle*MIRS_RADIUS);
	int speed = cmd[1];
	int end_time = cmd[4];
	int c_left, c_right;
	float speed_l, speed_r;
	int x_l, x_r;
	int dir=1; // dirction flag
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;

	printf("motor thread in\n");
	fprintf(fp,"rotate_thread\n");
	fclose_open('f');
	speed_l = -speed;
	speed_r = speed;

	v_l = (char)speed_l;
	v_r = (char)speed_r;
	fprintf(fp,"original vl = %d, vr = %d\n", v_l, v_r);
	fclose_open('f');

	if(abs(speed_l) > VLMAX){
		if(speed_l > 0){
			v_l = VLMAX; v_r = -VLMAX;
		}else{
			v_l = -VLMAX; v_r = VLMAX;
		}
	} else if(abs(speed_l)<VLMIN){
		if(speed_l > 0){
			v_l = VLMIN; v_r = -VLMIN;
		}else{
			v_l = -VLMIN; v_r = VLMIN;
		}
	}

	if(v_l>0){dir=-1;}

	v_lm = v_l; v_rm = v_r;

	dis=abs(dis)-(x_r_tmp-x_l_tmp)/2;

	pthread_mutex_lock(&mutex_motor);
	motor_send_start_packet (fd1);
	motor_send_start_packet (fd2);
	pthread_mutex_unlock(&mutex_motor);
	pthread_mutex_lock(&mutex_motor);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	//usleep(130000);
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);
	pthread_mutex_unlock(&mutex_motor);
	usleep(MOTOR_PERIOD);
	c_left=0; c_right=0;
	v_lm=v_l; v_rm=v_r;

	fprintf(fp,"rotation distance [mm] = %d\n",dis);
	fclose_open('f');

	while(1){
		/*
		if(abs(x_r) - abs(x_r_tmp) > v_rm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(abs(x_l) - abs(x_l_tmp) > v_lm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(v_l > 0 && x_l < -20)motor_restart_flag=1;
		if(v_l < 0 && x_l > 20)motor_restart_flag=1;
		if(v_r > 0 && x_r < -20)motor_restart_flag=1;
		if(v_r < 0 && x_r > 20)motor_restart_flag=1;
		*/
		if(end_time!=0){
			if((int)sp_time > end_time)time_end_flag=1;
			if(time_end_flag==1)break;
		}
		if(f_ts_flag==1)break;
		if(l_ts_flag==1)break;
		if(r_ts_flag==1)break;
		if(r_ws_flag==1)break;
		if(motor_restart_flag==1)break;

		pthread_mutex_lock(&mutex_motor);
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		pthread_mutex_unlock(&mutex_motor);
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		if(abs(x_l) > 1000 && abs(x_r) < abs(dis))x_l=-x_r;
		if(abs(x_r) > 1000 && abs(x_l) < abs(dis))x_r=-x_l;
		fprintf(fp,"vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		fclose_open('f');

		if(abs(dis)-abs(x_l) > 15 && abs(dis)-abs(x_r) > 15){
			if((x_l + x_r) > 10){
				v_lm=v_l-3; v_rm=v_r-3;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
				fprintf(fp,"v_lm = %d, v_rm = %d \n", v_lm, v_rm);
				fclose_open('f');
			}else if((x_l + x_r) < -10){
				v_lm=v_l+3; v_rm=v_r+3;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
				fprintf(fp,"v_lm = %d, v_rm = %d \n", v_lm, v_rm);
				fclose_open('f');
			}else{
				v_lm=v_l;
				v_rm=v_r;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_l,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_r,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
			}
		}
		if(abs(dis)-abs(x_l) < -15 && abs(dis)-abs(x_r) < -15){
			if((x_l + x_r) > 10){
				v_lm=-v_l-3; v_rm=-v_r-3;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
				fprintf(fp,"v_lm = %d, v_rm = %d \n", v_lm, v_rm);
				fclose_open('f');
			}else if((x_l + x_r) < -10){
				v_lm=-v_l+3; v_rm=-v_r+3;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_lm,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_rm,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
				fprintf(fp,"v_lm = %d, v_rm = %d \n", v_lm, v_rm);
				fclose_open('f');
			}else{
				v_lm=-v_l;
				v_rm=-v_r;
				pthread_mutex_lock(&mutex_motor);
				if(motor_send_control_packet(fd1,v_l,Kp,Ki) < 0) motor_restart_flag=1;
				if(motor_send_control_packet(fd2,v_r,Kp,Ki) < 0) motor_restart_flag=1;
				pthread_mutex_unlock(&mutex_motor);
			}
		}

		if(abs(x_l+dis*dir) < 15 && abs(x_r-dis*dir) < 15){
			pthread_mutex_lock(&mutex_motor);
			if(motor_send_control_packet(fd1,0,Kp,Ki) < 0) motor_restart_flag=1;
			if(motor_send_control_packet(fd2,0,Kp,Ki) < 0) motor_restart_flag=1;
			pthread_mutex_unlock(&mutex_motor);
			const_flag=1;
			break;
		}

		usleep(MOTOR_PERIOD);
		x_r_tmp=x_r;
		x_l_tmp=x_l;

		/*
		if(abs(x_r) - abs(x_r_tmp) > v_rm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(abs(x_l) - abs(x_l_tmp) > v_lm*10){
			fprintf(fp,"/////speed over!!/////\n");
			fclose_open('f');
			motor_restart_flag=1;
		}
		if(v_l > 0 && x_l < 0)motor_restart_flag=1;
		if(v_l < 0 && x_l > 0)motor_restart_flag=1;
		if(v_r > 0 && x_r < 0)motor_restart_flag=1;
		if(v_r < 0 && x_r > 0)motor_restart_flag=1;
		*/
		if(end_time!=0){
			if((int)sp_time > end_time)time_end_flag=1;
			if(time_end_flag==1)break;
		}
		if(f_ts_flag==1)break;
		if(l_ts_flag==1)break;
		if(r_ts_flag==1)break;
		if(r_ws_flag==1)break;
		if(motor_restart_flag==1)break;
		usleep(MOTOR_PERIOD);
		x_r_tmp=x_r;
		x_l_tmp=x_l;

	}

	pthread_mutex_lock(&mutex_motor);
	if(motor_send_control_packet(fd1,0,Kp,Ki) < 0){
		fprintf(stderr, "error");
		motor_restart_flag=1;
	}
	if(motor_send_control_packet(fd2,0,Kp,Ki) < 0){
		fprintf(stderr, "error");
		motor_restart_flag=1;
	}
	pthread_mutex_unlock(&mutex_motor);

	usleep(MOTOR_PERIOD);
	motor_stop_thread();
	usleep(130*1000);
	printf("motor thread exit\n");
	fprintf(fp,"r_uss_wall_flag = %d\nl_uss_wall_flag = %d\n",r_uss_wall_flag,l_uss_wall_flag);
	fprintf(fp,"f_ts_flag = %d\nl_ts_flag = %d\nr_ts_flag = %d\n",f_ts_flag,l_ts_flag,r_ts_flag);
	fprintf(fp,"time_end_flag = %d\nr_ws_flag = %d\n",time_end_flag,r_ws_flag);
	fprintf(fp,"motor_restart_flag = %d\nconst_flag = %d\n",motor_restart_flag,const_flag);
	fclose_open('f');
	x_r_tmp=x_r;
	x_l_tmp=x_l;
	if(time_end_flag==1)const_flag=1;
	if(const_flag==1){
		x_r_tmp=0;
		x_l_tmp=0;
	}
	mtask_flag=1;
	uss_exit_flag=1;
	ts_exit_flag=1;
	timer_exit_flag=1;
	pthread_exit(0);
	return 0;
}
