#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <errno.h>
#include "func_extern.h"
#include "motor.h"
#include "control.h"

#include "original.h"
#include "uss_control.h"
 

extern int r_uss_wall_flag;
extern int l_uss_wall_flag;
extern int f_ts_flag;
extern int r_ts_flag;
extern int l_ts_flag;
extern int r_ws_flag;
extern int ws_lock_flag;
extern int time_end_flag;
extern int motor_restart_flag;
extern int const_flag;
extern int exit_flag;

extern int x_r_tmp,x_l_tmp,x_r_tmp_keep,x_l_tmp_keep;

static void straight(void);
static void timer_straight(void);
static void motor_restart(void);
static void r_restore(void);
static void l_restore(void);
static void r_turn(void);
static void r_return(void);
static void l_turn(void);
static void l_return(void);
static void db(void);
static void key(void);
static void rotary(void);
static void kobeya(void);
static void goal(void);

enum states {STRAIGHT,TIMER_STRAIGHT,MOTOR_RESTART,R_RESTORE,L_RESTORE,R_TURN,R_RETURN,L_TURN,L_RETURN,KEY,DB,ROTARY,KOBEYA,GOAL};
enum {ENTRY,DO,EXIT} eod=ENTRY;
enum states state_tmp,state_tmp_keep,state=STRAIGHT;

int r1_def,l1_def,l2_def;
extern int uss_use;

FILE *fp,*uss_fp,*state_fp,*step_fp,*obst_fp,*eod_fp;
int obst=0;
int obst_keep=0;
int obst_log[10];
int step=0;
int step_keep=0;
int goal_flag=0;
int flag_esc=0;
int motion_param[5];
int rotary_flag=0;
int kobeya_flag=0;
int kobeya_exit_flag=0;
int kobeya_state=0;
int straight_time=0;
int timer_straight_speed=0;
int turn_counter;
time_t start_time;
char coursee;
char word[50];


int main(void){
	initialize();
	printf("starting...\n");
	fprintf(fp,"/**********start**********/\n");
	fprintf(fp,"state=%d,step=%d,obst=%d,eod=%d\n",state,step,obst,eod);
	fclose_open('f');

	
	while(1){
		switch(state){
			case STRAIGHT:
				straight();				/////142
				break;
			case TIMER_STRAIGHT:
				timer_straight();		/////189
				break;
			case MOTOR_RESTART:
				motor_restart();		/////236
				break;
			case R_RESTORE:
				r_restore();			/////292
				break;
			case L_RESTORE:
				l_restore();			/////378
				break;
			case R_TURN:
				r_turn();				/////466
				break;
			case R_RETURN:
				r_return();				/////550
				break;
			case L_TURN:
				l_turn();				/////630
				break;
			case L_RETURN:
				l_return();				/////712
				break;
			case DB:
				db();					/////788
				break;
			case KEY:
				key();					/////887
				break;
			case ROTARY:
				rotary();				/////954
				break;
			case KOBEYA:
				kobeya();				/////994
				break;
			case GOAL:
				goal();					/////1036
				break;
			default :
				break;
		}
		//usleep(5000);
		if(goal_flag==1)break;
	}
	

	printf("end\n");
	
	printf("closing device...\n");
	close(fd1);
	close(fd2);
	close(fd4);
	fclose(fp);
	printf("end\n");
	printf("Finish!!\n");

	return 0;
}


/*******************motion functions**********************/
void straight(void){
	int straight_speed=ORIGINAL_MOTOR_SPEED;
	if(eod==ENTRY){
		printf("/**********straight**********/\n");
		fprintf(fp,"/**********straight**********/\n");
		fclose_open('f');
		log_printf();
		sprintf((char*)word,"tu'urowo/so'ukouwo/sima_su");
		talk(word);
		r1_def=R1_DEF;
		l1_def=L1_DEF;
		l2_def=L2_DEF;
		uss_use=21;
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		motion_param[0]=straight_speed;
		motion_param[4]=0;
		pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
		pthread_create(&uss_task,&attr_uss,uss_thread,NULL);
		pthread_create(&motor_task1, &attr_motor1,original_straight_thread,motion_param);
		//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
		pthread_join(motor_task1, NULL);
		//pthread_join(motor_task2, NULL);
		pthread_join(uss_task, NULL);
		pthread_join(irs_ts_ws_task,NULL);
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		judge_state();
		state_tmp=STRAIGHT;
		eod=ENTRY;
	}
}


void timer_straight(void){
	if(eod==ENTRY){
		printf("/**********timer_straight**********/\n");
		fprintf(fp,"/**********timer_straight**********/\n");
		fclose_open('f');
		log_printf();
		sprintf((char*)word,"tyokushinshima_su");
		talk(word);
		time( &start_time );
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		motion_param[0]=timer_straight_speed;
		motion_param[1]=1;
		motion_param[4]=straight_time;
		pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
		pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
		pthread_create(&motor_task1, &attr_motor1,original_straight_thread,motion_param);
		//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
		pthread_join(motor_task1, NULL);
		//pthread_join(motor_task2, NULL);
		pthread_join(irs_ts_ws_task,NULL);
		pthread_join(timer_task, NULL);
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		irs_ts_ws_get();
		if(time_end_flag==1)state=STRAIGHT;
		if(r_ts_flag==1)state=R_RESTORE;
		if(l_ts_flag==1)state=L_RESTORE;
		if(r_ws_flag==1)state=DB;
		state_tmp=TIMER_STRAIGHT;
		flag_reset();
		eod=ENTRY;
	}
}


void motor_restart(void){
	char command[100];
	if(eod==ENTRY){
		printf("/**********motor_restart**********/\n");
		fprintf(fp,"/**********motor_restart**********/\n");
		fclose_open('f');
		fprintf(state_fp,"%d,%d,%d\n",state,state_tmp,state_tmp_keep);
		log_printf();
		sprintf((char*)word,"mouta'a;/risuta'atowo/okonatteima_su");
		talk(word);
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		close(fd1);
		close(fd2);
		sprintf(command, "/sbin/rmmod mg3_sci\n");
		system(command);
		sprintf(command, "/sbin/insmod /lib/modules/`uname -r`/misc/mg3_sci.ko\n");
		system(command);
		sprintf(command, "/home/mirs/bin/aritecdownload -b -v /home/mirs/etc/isaio_whole.ttf\n");
		system(command);
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		fd1 = open(M_PORT_L, O_RDWR);
		if(fd1 < 0){
			if(errno == 3) printf("no such file\n");
			else if(errno == 13) printf("permission\n");
			else printf("other\n");
			fprintf(stderr, "fd1 open error\n");
			exit(-1);
		}
		fd2 = open(M_PORT_R, O_RDWR);
		if(fd2 < 0){
			fprintf(stderr, "fd2 open error\n");
			close(fd1);
			exit(-1);
		}
		sleep(1);
		state=state_tmp;
		state_tmp=MOTOR_RESTART;
		eod=DO;
	}
		
}


void r_restore(void){
	int r_uss=0,ret=0;
	if(eod==ENTRY){
		printf("/**********r_restore**********/\n");
		fprintf(fp,"/**********r_restore*********/\n");
		fclose_open('f');
		log_printf();
		sprintf((char*)word,"hi'darini/hoseishima_su");
		talk(word);
		step_keep=step;
		step=1;
		x_r_tmp_keep=x_r_tmp;
		x_r_tmp=0;
		x_l_tmp_keep=x_l_tmp;
		x_l_tmp=0;
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		switch(step){
			case 1:
				fprintf(fp,"/**********step1*********/\n");
				fclose_open('f');
				time( &start_time );
				motion_param[0]=RESTORE_STEP1_VAL;
				motion_param[1]=RESTORE_STEP1_SPEED;
				motion_param[4]=10;
				pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
				pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
				//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
				pthread_join(motor_task1, NULL);
				//pthread_join(motor_task2, NULL);
				pthread_join(timer_task, NULL);
				if(const_flag==1)step=2;
				break;
			case 2:
				fprintf(fp,"/**********step2*********/\n");
				fclose_open('f');
				if(obst!=1){
					time( &start_time );
					motion_param[0]=R_RESTORE_STEP2_ANGLE;
					motion_param[1]=R_RESTORE_STEP2_SPEED;
					motion_param[4]=10;
					pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,motion_param);
					pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
					//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
					pthread_join(motor_task1, NULL);
					//pthread_join(motor_task2, NULL);
					pthread_join(timer_task, NULL);
					if(const_flag==1)step=3;
				}else step=3;
				break;
			case 3:
				if(state_tmp!=ROTARY&&state_tmp_keep!=ROTARY&&obst!=11){
					ret=correction();
					if(const_flag==1||ret == -1)step=0;
				}else step=0;
				break;
			default:
				break;
		}
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		if(motor_restart_flag==1){
			state_tmp_keep=state_tmp;
			state_tmp=R_RESTORE;
			state=MOTOR_RESTART;
		}
		if(step==0){
			step=step_keep;
			state=state_tmp;
			if(state_tmp==MOTOR_RESTART)state=state_tmp_keep;
			if(state!=STRAIGHT&&state!=KOBEYA){
				x_r_tmp=x_r_tmp_keep-30;
				x_l_tmp=x_l_tmp_keep-30;
			}
			state_tmp=R_RESTORE;
		}
		flag_reset();
		if(state==MOTOR_RESTART||state==STRAIGHT)eod=ENTRY;
		else eod=DO;
	}	
}


void l_restore(void){
	int r_uss=0,ret=0;
	if(eod==ENTRY){
		printf("/**********l_restore**********/\n");
		fprintf(fp,"/**********l_restore**********/\n");
		fclose_open('f');
		log_printf();
		sprintf((char*)word,"hoseishima_su");
		talk(word);
		step_keep=step;
		step=1;
		x_r_tmp_keep=x_r_tmp;
		x_r_tmp=0;
		x_l_tmp_keep=x_l_tmp;
		x_l_tmp=0;
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		switch(step){
			case 1:
				fprintf(fp,"/**********step1*********/\n");
				fclose_open('f');
				time( &start_time );
				motion_param[0]=RESTORE_STEP1_VAL;
				motion_param[1]=RESTORE_STEP1_SPEED;
				motion_param[4]=10;
				pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
				pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
				//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
				pthread_join(motor_task1, NULL);
				//pthread_join(motor_task2, NULL);
				pthread_join(timer_task, NULL);
				if(const_flag==1)step=2;
				break;
			case 2:
				fprintf(fp,"/**********step2*********/\n");
				fclose_open('f');
				if(obst!=1){
					r_uss=uss_get(3);
					time( &start_time );
					motion_param[0]=L_RESTORE_STEP2_ANGLE;
					motion_param[1]=L_RESTORE_STEP2_SPEED;
					motion_param[4]=10;
					pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
					pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,motion_param);
					//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
					pthread_join(motor_task1, NULL);
					//pthread_join(motor_task2, NULL);
					pthread_join(timer_task, NULL);
					if(const_flag==1)step=3;
				}else step=3;
				break;
			case 3:
				if(state_tmp!=ROTARY&&state_tmp_keep!=ROTARY&&obst!=11){
					ret=correction();
					if(const_flag==1||ret==-1)step=0;
				}else step=0;
				break;
			default:
				break;
		}
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		if(motor_restart_flag==1){
			state_tmp_keep=state_tmp;
			state_tmp=L_RESTORE;
			state=MOTOR_RESTART;
		}
		if(step==0){
			step=step_keep;
			state=state_tmp;
			if(state_tmp==MOTOR_RESTART)state=state_tmp_keep;
			if(state!=STRAIGHT&&state!=KOBEYA){
				x_r_tmp=x_r_tmp_keep-30;
				x_l_tmp=x_l_tmp_keep-30;
			}
			state_tmp=L_RESTORE;
		}
		flag_reset();
		if(state==MOTOR_RESTART||state==STRAIGHT)eod=ENTRY;
		else eod=DO;
	}
}


void r_turn(void){
	int ret=0,adj=0;
	if(eod==ENTRY){
		printf("/**********r_turn**********/\n");
		fprintf(fp,"/**********r_turn**********/\n");
		fclose_open('f');
		log_printf();
		sprintf((char*)word,"migihemagarima_su");
		talk(word);
		if(state_tmp==R_RETURN)turn_counter++;
		else turn_counter=0;
		if(turn_counter==4)step=0;
		else step=1;
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		switch(step){
			case 1:
				ret=correction();
				if(const_flag==1||ret==-1)step=2;
				break;
			case 2:
				fprintf(fp,"/**********step1*********/\n");
				fclose_open('f');
				if(state_tmp==ROTARY)adj=100;
				else adj=0;
				motion_param[0]=R_TURN_STEP1_VAL-adj;
				motion_param[1]=1;
				motion_param[4]=0;
				pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
				pthread_create(&motor_task1, &attr_motor1,mk_right_turn,motion_param);
				pthread_join(motor_task1, NULL);
				pthread_join(irs_ts_ws_task, NULL);
				if(const_flag==1)step=3;
				break;
			case 3:
				fprintf(fp,"/**********step2*********/\n");
				fclose_open('f');
				motion_param[0]=R_TURN_STEP2_VAL;
				motion_param[1]=R_TURN_STEP2_SPEED;
				motion_param[4]=0;
				pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
				pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
				//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
				pthread_join(motor_task1, NULL);
				//pthread_join(motor_task2, NULL);
				pthread_join(irs_ts_ws_task, NULL);
				if(const_flag==1)step=4;
				break;
			case 4:
				ret=correction();
				if(const_flag==1||ret==-1)step=0;
				break;
			default:
				break;
		}
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		irs_ts_ws_get();
		if(motor_restart_flag==1){
			state=MOTOR_RESTART;
			state_tmp=R_TURN;
		}
		if(step==0){
			if(obst==11)obst=1;//カーブ中の補正の有効化
			state=STRAIGHT;
			state_tmp=R_TURN;
		}
		if(step==2){
			if(r_ts_flag==1||l_ts_flag==1){
				state=R_RETURN;
				state_tmp=R_TURN;
				flag_esc=r_ts_flag;
				step=0;
			}
		}
		if(step==3){
			if(r_ts_flag==1)state=R_RESTORE;
			if(l_ts_flag==1)state=L_RESTORE;
			state_tmp=R_TURN;
		}
		if(r_ws_flag==1){
			state=DB;
			step=0;
			state_tmp=R_TURN;
		}
		flag_reset();
		if(step==0||state==R_RESTORE||state==L_RESTORE||state==MOTOR_RESTART||state==R_RETURN)eod=ENTRY;
		else eod=DO;
	}
}

void r_return(void){
	int dir;
	static int x_l_dis;
	if(eod==ENTRY){
		printf("/**********r_return**********/\n");
		fprintf(fp,"/**********r_return**********/\n");
		fclose_open('f');
		log_printf();
		sprintf((char*)word,"kabeniatarima'shita /hoseiwookonaima_su");
		talk(word);
		step=1;
		x_l_dis=x_l_tmp;
		x_l_tmp=0;
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		switch(step){
			case 1:
				fprintf(fp,"/**********step1*********/\n");
				fclose_open('f');
				//time( &start_time );
				motion_param[0]=x_l_dis;
				motion_param[1]=-1;
				motion_param[4]=0;
				pthread_create(&motor_task1, &attr_motor1,mk_right_turn,motion_param);
				//pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
				pthread_join(motor_task1, NULL);
				//pthread_join(timer_task, NULL);
				//fprintf(fp,"/////r_return finish/////\n");
				//fclose_open('f');
				if(const_flag==1)step=2;
				break;
			case 2:
				fprintf(fp,"/**********step2*********/\n");
				fclose_open('f');
				if(flag_esc==1)dir=1;
				else dir=-1;
				time( &start_time );
				motion_param[0]=R_RETURN_STEP2_VAL*dir;
				motion_param[1]=R_RETURN_STEP2_SPEED*dir;
				motion_param[4]=5;
				pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
				//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
				pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
				pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
				pthread_join(motor_task1, NULL);
				//pthread_join(motor_task2, NULL);
				pthread_join(timer_task, NULL);
				pthread_join(irs_ts_ws_task, NULL);
				if(const_flag==1)step=0;
				break;
			default:
				break;
		}
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		irs_ts_ws_get();
		if(motor_restart_flag==1)state=MOTOR_RESTART;
		if(r_ts_flag==1)state=R_RESTORE;
		if(l_ts_flag==1)state=L_RESTORE;
		if(step==0)state=R_TURN;
		if(r_ws_flag==1)state=DB;
		flag_reset();
		state_tmp=R_RETURN;
		if(step==0||state==MOTOR_RESTART||state==R_RESTORE||state==L_RESTORE)eod=ENTRY;
		else eod=DO;
	}
}

void l_turn(void){
	int ret=0;
	int adj=0;
	if(eod==ENTRY){
		printf("/**********l_turn**********/\n");
		fprintf(fp,"/**********l_turn**********/\n");
		fclose_open('f');
		log_printf();
		sprintf((char*)word,"hidarinimagarima_su");
		talk(word);
		if(state_tmp==R_RETURN)turn_counter++;
		else turn_counter=0;
		if(turn_counter==4)step=0;
		else step=1;
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		switch(step){
			case 1:
				ret=correction();
				if(const_flag==1||ret==-1)step=2;
				break;
			case 2:
				fprintf(fp,"/**********step1*********/\n");
				fclose_open('f');
				if(state_tmp==ROTARY)adj=100;
				else adj=0;
				motion_param[0]=L_TURN_STEP1_VAL-adj;
				motion_param[1]=1;
				motion_param[4]=0;
				pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
				pthread_create(&motor_task1, &attr_motor1,mk_left_turn,motion_param);
				pthread_join(motor_task1, NULL);
				pthread_join(irs_ts_ws_task, NULL);
				if(const_flag==1)step=3;
				break;
			case 3:
				fprintf(fp,"/**********step2*********/\n");
				fclose_open('f');
				motion_param[0]=L_TURN_STEP2_VAL;
				motion_param[1]=L_TURN_STEP2_SPEED;
				motion_param[4]=0;
				pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
				pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
				//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
				pthread_join(motor_task1, NULL);
				//pthread_join(motor_task2, NULL);
				pthread_join(irs_ts_ws_task, NULL);
				if(const_flag==1)step=0;
				break;
			case 4:
				ret=correction();
				if(const_flag==1||ret==-1)step=0;
				break;
			default:
				break;
		}
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		irs_ts_ws_get();
		if(motor_restart_flag==1)state=MOTOR_RESTART;
		if(step==0){
			if(obst==11)obst=1;//カーブ中の補正の有効化
			state=STRAIGHT;
		}
		if(step==2){
			if(r_ts_flag==1||l_ts_flag==1){
				state=L_RETURN;
				flag_esc=r_ts_flag;
				step=0;
			}
		}
		if(step==3){
			if(r_ts_flag==1)state=R_RESTORE;
			if(l_ts_flag==1)state=L_RESTORE;
		}
		if(r_ws_flag==1){
			state=DB;
			step=0;
		}
		flag_reset();
		state_tmp=L_TURN;
		if(step==0||state==R_RESTORE||state==L_RESTORE||state==MOTOR_RESTART||state==L_RETURN)eod=ENTRY;
		else eod=DO;
	}
}

void l_return(void){
	int dir;
	static int x_r_dis;
	if(eod==ENTRY){
		printf("/**********l_return**********/\n");
		fprintf(fp,"/**********l_return**********/\n");
		fclose_open('f');
		log_printf();
		sprintf((char*)word,"kabeniatarima'sita /hoseiwookonaima_su");
		talk(word);
		x_r_dis=x_r_tmp;
		x_r_tmp=0;
		step=1;
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		switch(step){
			case 1:
				fprintf(fp,"/**********step1*********/\n");
				fclose_open('f');
				time( &start_time );
				motion_param[0]=x_r_dis;
				motion_param[1]=-1;
				motion_param[4]=0;
				pthread_create(&motor_task1, &attr_motor1,mk_left_turn,motion_param);
				//pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
				pthread_join(motor_task1, NULL);
				//pthread_join(timer_task, NULL);
				if(const_flag==1)step=2;
				break;
			case 2:
				fprintf(fp,"/**********step2*********/\n");
				fclose_open('f');
				if(flag_esc==1)dir=-1;
				else dir=1;
				time( &start_time );
				motion_param[0]=L_RETURN_STEP2_VAL*dir;
				motion_param[1]=L_RETURN_STEP2_SPEED*dir;
				motion_param[4]=5;
				pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
				//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
				pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
				pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
				pthread_join(motor_task1, NULL);
				//pthread_join(motor_task2, NULL);
				pthread_join(timer_task, NULL);
				pthread_join(irs_ts_ws_task, NULL);
				if(const_flag==1)step=0;
				break;
			default:
				break;
		}
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		irs_ts_ws_get();
		if(motor_restart_flag==1)state=MOTOR_RESTART;
		if(r_ts_flag==1)state=R_RESTORE;
		if(l_ts_flag==1)state=L_RESTORE;
		if(step==0)state=L_TURN;
		if(r_ws_flag==1)state=DB;
		flag_reset();
		state_tmp=L_RETURN;
		if(step==0||state==MOTOR_RESTART||state==R_RESTORE||state==L_RESTORE)eod=ENTRY;
		else eod=DO;
	}
}

void db(void){
	int ret=0,uss_1=0;
	int *DB_center;
	int center_angle=0,center_speed=0;
	char *DB_course,bbb;
	//char* course;
	if(eod==ENTRY){
		printf("/**********DB**********/\n");
		fprintf(fp,"/**********DB**********/\n");
		fclose_open('f');
		log_printf();
		sprintf((char*)word,"gazouni'nnsikiwo/okonatteima_su");
		talk(word);
		step=1;
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		switch(step){
			case 1:
				ret=correction();
				if(const_flag==1||ret==-1)step=2;
				break;
			case 2:
				if(state_tmp!=MOTOR_RESTART)bbb=DB_knock(&DB_course,&DB_center);
				center_angle=DB_center;
				coursee=DB_course;
				if(center_angle < 10 && center_angle > -10)center_angle=0;
				if(center_angle > 0)center_speed=15;
				else center_speed=-15;
				fprintf(fp,"center = %d,%d\n course = %c,%c\n",DB_center,center_angle,coursee);
				if(center_angle==0||bbb==-1){
					step=3;
				}else{
					time( &start_time );
					motion_param[0]=center_angle;
					motion_param[1]=center_speed;
					motion_param[4]=10;
					pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
					pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,motion_param);
					//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
					pthread_join(motor_task1, NULL);
					//pthread_join(motor_task2, NULL);
					pthread_join(timer_task,NULL);
				}
				if(motor_restart_flag!=1)step=3;
				break;
			case 3:
				ws_lock_flag=1;
				time( &start_time );
				if(coursee=='R'){
					motion_param[0]=DB_VAL;
					motion_param[1]=DB_SPEED;
					motion_param[4]=5;
				}else if(coursee=='L'){
					motion_param[0]=DB_VAL;
					motion_param[1]=DB_SPEED;
					motion_param[4]=5;
				}else{
					printf("数字認識失敗\n");
					sprintf((char*)word,"are?suujigayome'nai/na'a /mouikka'i/mouikka'i");
					talk(word);
					uss_1=uss_get(1);
					if(uss_1 > 80){
						step=0;
						break;
					}
					motion_param[0]=DB_E_VAL;
					motion_param[1]=DB_E_SPEED;
					motion_param[4]=1;
				}
				pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
				pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
				//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
				pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
				pthread_join(irs_ts_ws_task, NULL);
				pthread_join(motor_task1, NULL);
				//pthread_join(motor_task2, NULL);
				pthread_join(timer_task,NULL);
				printf("course=%c\n",coursee);
				if(const_flag==1){
					step=0;
					ws_lock_flag=0;
				}
				break;
			default:
				break;
		}
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		irs_ts_ws_get();
		if(motor_restart_flag==1)state=MOTOR_RESTART;
		if(r_ts_flag==1)state=R_RESTORE;
		if(l_ts_flag==1)state=L_RESTORE;
		if(step==0){
			if(coursee=='R'){
				state=R_TURN;
			}else if(coursee=='L'){
				state=L_TURN;
			}else{
				state=STRAIGHT;
			}
		}
		flag_reset();
		state_tmp=DB;
		if(step==0||state==MOTOR_RESTART||state==R_RESTORE||state==L_RESTORE)eod=ENTRY;
		else eod=DO;
	}
}

void key(void){
	int ret=0;
	if(eod==ENTRY){
		printf("/**********key**********/\n");
		fprintf(fp,"/**********key**********/\n");
		fclose_open('f');
		log_printf();
		sprintf((char*)word,"kagi/ge'xtutoooooooooo");
		talk(word);
		step=1;
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		switch(step){
			case 1:
				time(&start_time);
				fprintf(fp,"/**********step1*********/\n");
				motion_param[0]=KEY_STEP1_VAL;
				motion_param[1]=KEY_STEP1_SPEED;
				motion_param[4]=10;
				//pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
				pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
				pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
				//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
				pthread_join(motor_task1, NULL);
				//pthread_join(motor_task2, NULL);
				pthread_join(timer_task, NULL);
				if(motor_restart_flag!=1)step=2;
				break;
			case 2:
				ret=correction();
				if(const_flag==1||ret==-1)step=3;
				break;
			case 3:
				time(&start_time);
				fprintf(fp,"/**********step2*********/\n");
				//ここあやしい
				motion_param[0]=KEY_STEP2_ANGLE;
				motion_param[1]=KEY_STEP2_SPEED;
				motion_param[4]=10;
				pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
				pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,motion_param);
				//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
				pthread_join(motor_task1, NULL);
				pthread_join(timer_task, NULL);
				if(const_flag==1)step=4;
				if(time_end_flag==1)step=3;
				break;
			case 4:
				ret=correction();
				if(const_flag==1||ret==-1)step=0;
				break;
		}
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		irs_ts_ws_get();
		if(motor_restart_flag==1)state=MOTOR_RESTART;
		if(step==0){
			state=STRAIGHT;
			obst=2;
		}
		state_tmp=KEY;
		flag_reset();
		if(step==0||state==MOTOR_RESTART)eod=ENTRY;
		else eod=DO;
	}
}


void rotary(void){
	if(eod==ENTRY){
		printf("/***********rotary**********/\n");
		fprintf(fp,"/**********rotary**********/\n");
		fclose_open('f');
		log_printf();
		sprintf((char*)word,"ro'otariini/hairima'sita");
		talk(word);
		step=1;
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		rotary_control();
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		irs_ts_ws_get();
		if(motor_restart_flag==1)state=MOTOR_RESTART;
		if(r_ws_flag==1)state=DB;
		if(r_ts_flag==1){
			if(step!=3)state=R_RESTORE;
			if(step==3)state=L_RESTORE;
		}
		if(l_ts_flag==1){
			if(step!=3)state=L_RESTORE;
			if(step==3)state=R_RESTORE;
		}	

		if(step==0){
			if(exit_flag==9||exit_flag==12)state=L_TURN;
			if(exit_flag==3)state=R_TURN;
			//state=STRAIGHT;
			//straig\ht_time=10;
			//timer_straight_speed=50;
			obst=-1;
		}
		state_tmp=ROTARY;
		flag_reset();
		if(step==0||state==MOTOR_RESTART||state==R_RESTORE||state==L_RESTORE)eod=ENTRY;
		else eod=DO;
	}
}		

void kobeya(void){
	if(eod==ENTRY){
		printf("/**********KOBEYA**********/\n");
		fprintf(fp,"/**********KOBEYA**********/\n");
		fclose_open('f');
		log_printf();
		sprintf((char*)word,"kobeyanihairima_shita");
		talk(word);
		kobeya_flag=1;
		step=1;
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		kobeya_left_control();
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		irs_ts_ws_get();
		if(motor_restart_flag==1)state=MOTOR_RESTART;
		if(r_ts_flag==1)state=R_RESTORE;
		if(l_ts_flag==1)state=L_RESTORE;
		if(r_ws_flag==1)state=DB;
		if(step==0){
			sprintf((char*)word,"kobeyawonukedashima_su");
			talk(word);
			state=L_TURN;
			if(kobeya_exit_flag==1)state=STRAIGHT;
			kobeya_exit_flag=0;
			kobeya_flag=0;
			obst=-1;
		}
		state_tmp=KOBEYA;
		flag_reset();
		if(step==0||state==MOTOR_RESTART||state==R_RESTORE||state==L_RESTORE)eod=ENTRY;
		else eod=DO;
	}
}

void goal(void){
	if(eod==ENTRY){
		printf("GOAL!!\n");
		fprintf(fp,"/**********GOAL!!**********/\n");
		fclose_open('f');
		log_printf();
		eod=DO;
	}
	if(eod==DO){
		log_printf();
		motion_param[0]=GOAL_VAL;
		motion_param[1]=GOAL_SPEED;
		motion_param[4]=0;
		pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
		//pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
		pthread_join(motor_task1, NULL);
		eod=EXIT;
	}
	if(eod==EXIT){
		log_printf();
		irs_ts_ws_get();
		if(motor_restart_flag==1)state=MOTOR_RESTART;
		if(r_ws_flag==1&&const_flag==1){
			sprintf((char*)word,"go'oruda wa'ai! ureshi'ina ");
			talk(word);
			goal_flag=1;
		}
		else state=STRAIGHT;
		state_tmp=GOAL;
		eod=ENTRY;
	}
}
        
void fclose_open(char c){
	switch(c){
		case 'f':
			fclose(fp);
			fp=fopen("../output/out.txt","a");
			break;
		case 'u':
			fclose(uss_fp);
			uss_fp=fopen("../output/uss.txt","a");
			break;
		case 's':
			fclose(state_fp);
			state_fp=fopen("../output/state.txt","a");
			break;
		case 'p':
			fclose(step_fp);
			step_fp=fopen("../output/step.txt","a");
			break;
		case 'o':
			fclose(obst_fp);
			obst_fp=fopen("../output/obst.txt","a");
			break;
		case 'e':
			fclose(eod_fp);
			eod_fp=fopen("../output/eod.txt","a");
			break;
	}
}

void log_printf(void){
	fprintf(state_fp,"%d,%d,%d\n",state,state_tmp,state_tmp_keep);
	fclose_open('s');
	fprintf(eod_fp,"%d\n",eod);
	fclose_open('e');
	fprintf(step_fp,"%d,%d\n",step,step_keep);
	fclose_open('p');
	fprintf(obst_fp,"%d\n",obst);
	fclose_open('o');
	return ;
}
