
/*
 * rotary_control.c
 *
 *  Created on: 2013/01/12
 *      Author: Kosuke
 */


#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <errno.h>
#include "func_extern.h"
#include "motor.h"
#include "control.h"
#include "rotary.h"
#include "uss_control.h"

extern int rotary_center;
//extern int rotary_distance;
extern int time_end_flag;
extern int const_flag;
extern int r_uss_wall_flag;
extern int l_uss_wall_flag;
extern int f_ts_flag;
static void r_step1(void);
static void r_step2(void);
static void r_step3(void);
static void r_step4(void);
static void r_step5(void);
static void r_step6(void);
static void r_step7(void);
/*static void r_step8(void);
static void rotary_end(void);*/

extern FILE *fp;
extern int step;
extern int motion_param[5];
extern char word[50];
int exit_flag=0;
int l1_def;
int r1_def;
int l2_def;
int center_speed;
extern int uss_use;
extern time_t start_time;
int rotary_back_count=0;
extern int x_r_tmp,x_l_tmp;
extern int rotary_flag;

void rotary_control(void){
		switch(step){
			case 1:
				r_step1();
				fprintf(fp,"step1 finish...\n");
				fclose_open('f');
				break;
			case 2:
				r_step2();
				fprintf(fp,"step2 finish...\n");
				fclose_open('f');
				break;
			case 3:
				r_step3();
				fprintf(fp,"step3 finish...\n");
				fclose_open('f');
				break;
			case 4:
				r_step4();
				fprintf(fp,"step4 finish...\n");
				fclose_open('f');
				break;
			case 5:
				r_step5();
				fprintf(fp,"step5 finish...\n");
				fclose_open('f');
				break;
			case 6:
				r_step6();
				fprintf(fp,"step6 finish...\n");
				fclose_open('f');
				break;
			case 7:
				r_step7();
				fprintf(fp,"step7 finish...\n");
				fclose_open('f');
				break;
/*
			case 8:
				r_step8();
				fprintf(fp,"step8 finish...\n");
				fclose_open('f');
				break;
			case 9:
				rotary_end();
				fprintf(fp,"rotary_end finish...\n");
				fclose_open('f');
				break;
*/
			default :
				break;
		}
	return;
}

void r_step1(void){
	rotary_flag=1;
	sprintf((char*)word,"ka'kudowo/hoseishima_su");
	talk(word);
	if(rotary_center!=0){
		motion_param[0]=rotary_center;
		if(rotary_center > 0) center_speed=30;
		else center_speed=-30;
		motion_param[1]=center_speed;
		fprintf(fp,"motion_param=%d\n",motion_param[0]);
		fprintf(fp,"motion_param=%d\n",motion_param[1]);
		fclose_open('f');
		pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,motion_param);
//		pthread_create(&, &attr_motor2,sub_motor_thread,NULL);
		pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
		pthread_join(motor_task1, NULL);
//		pthread_join(motor_task2, NULL);
		pthread_join(irs_ts_ws_task,NULL);
		if(const_flag==1)
			step=2;
	}
	else{step=2;}
}

void r_step2(void){
	int *val,*f_val;
	int *c;
	conor_detect(&c,&val,&f_val);
	fprintf(fp,"/////conor:c = %c,val = %d/////\n",c,val);
	fclose_open('f');
	rotary_center=val;
	//rotary_distance=f_val;
	rotary_center=-rotary_center;
	if(rotary_center!=0){
		motion_param[0]=rotary_center;
		if(rotary_center > 0) center_speed=30;
		else center_speed=-30;
		motion_param[1]=center_speed;
		fprintf(fp,"motion_param=%d\n",motion_param[0]);
		fprintf(fp,"motion_param=%d\n",motion_param[1]);
		fclose_open('f');
		pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,motion_param);
	//	pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
		pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
		pthread_join(motor_task1, NULL);
	//	pthread_join(motor_task2, NULL);
		pthread_join(irs_ts_ws_task,NULL);
		if(const_flag==1)
			step=3;
	}
	else{step=3;}
}

void r_step3(void){
	time(&start_time);
	sprintf((char*)word,"hasira'ni/butukarima_su");
	talk(word);
	motion_param[0]=ROT_STEP2_VAL;
	motion_param[1]=ROT_STEP2_TIME;
	motion_param[4]=5;
	fprintf(fp,"motion_param=%d\n",motion_param[0]);
	fprintf(fp,"motion_param=%d\n",motion_param[1]);
	fclose_open('f');
	pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
	pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
//	pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
	pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
	pthread_join(motor_task1, NULL);
//	pthread_join(motor_task2, NULL);
	pthread_join(irs_ts_ws_task,NULL);
	pthread_join(timer_task, NULL);
	if(f_ts_flag==1){
			fprintf(fp,"/////front_touch/////\n");
			x_r_tmp=0;
			x_l_tmp=0;
			step=4;
	}
}
void r_step4(void){
	time(&start_time);
	motion_param[0]=-20;
	motion_param[1]=-20;
	motion_param[4]=1;
	fprintf(fp,"motion_param=%d\n",motion_param[0]);
	fprintf(fp,"motion_param=%d\n",motion_param[1]);
	fclose_open('f');
	sprintf((char*)word,"pi'xtu /pi'xtu./ba'kkusima_su");
	talk(word);
	pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
	pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
//	pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
	pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
	pthread_join(motor_task1, NULL);
//	pthread_join(motor_task2, NULL);
	pthread_join(irs_ts_ws_task,NULL);
	pthread_join(timer_task, NULL);
	rotary_back_count++;
	if(rotary_back_count==7)step=5;
}


void r_step5(void){
	sprintf((char*)word,"gazousho'riwo/okonaima_su");
	talk(word);
	time(&start_time);
	motion_param[0]=ROT_STEP3_ANGLE;
	motion_param[1]=ROT_STEP3_TIME;
	motion_param[4]=5;
	fprintf(fp,"motion_param=%d\n",motion_param[0]);
	fprintf(fp,"motion_param=%d\n",motion_param[1]);
	fclose_open('f');
	pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
	pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,motion_param);
//	pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
	pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
	pthread_join(motor_task1, NULL);
//	pthread_join(motor_task2, NULL);
	pthread_join(irs_ts_ws_task,NULL);
	pthread_join(timer_task, NULL);
	exit_flag=exit_detect('r');
	fprintf(fp,"exit_flag=%d\n",exit_flag);
	fclose_open('f');
	if(exit_flag==9){
		sprintf((char*)word,"tyo'uiine  /de'guchiwa/ku'jino/houkoude_su");
		talk(word);
		if(const_flag==1)step=6;
		//出口は左
	}
	if(exit_flag==3){
		sprintf((char*)word,"tyo'uiine  /de'guchiwa/sa'njino/houkoude_su");
		talk(word);
		time(&start_time);
		motion_param[0]=ROT_r_STEP3_ANGLE;
		motion_param[1]=ROT_r_STEP3_TIME;
		motion_param[4]=5;
		fprintf(fp,"motion_param=%d\n",motion_param[0]);
		fclose_open('f');
		fprintf(fp,"motion_param=%d\n",motion_param[1]);
		fclose_open('f');
		pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
		pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,motion_param);
//		pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
		pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
		pthread_join(motor_task1, NULL);
//		pthread_join(motor_task2, NULL);
		pthread_join(irs_ts_ws_task,NULL);
		pthread_join(timer_task, NULL);
		if(const_flag==1)step=6;
		//出口は右
	}
	if(exit_flag==12){
		sprintf((char*)word,"tyo'uiine  /de'guchiwa/juuniji'no/houkoude_su");
		talk(word);
		if(const_flag==1)step=6;
		//出口は裏
	}
}
void r_step6(void){
	motion_param[0]=ROT_SIDE_STEP1_VAL;
	motion_param[1]=ROT_SIDE_STEP1_TIME;
	fprintf(fp,"motion_param=%d\n",motion_param[0]);
	fclose_open('f');
	fprintf(fp,"motion_param=%d\n",motion_param[1]);
	fclose_open('f');
	sprintf((char*)word,"de'guchiwa/do'ko?");
	talk(word);
	pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
//	pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
	pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
	pthread_join(motor_task1, NULL);
//	pthread_join(motor_task2, NULL);
	pthread_join(irs_ts_ws_task,NULL);
	if(const_flag==1)step=7;
}

void r_step7(void){
	time(&start_time);
	r1_def=ROT_USS_DEF;
	l1_def=ROT_USS_DEF;
	l2_def=L2_DEF;
	motion_param[0]=5;
	motion_param[4]=0;
	if(exit_flag==9||exit_flag==12){
		uss_use=10;
		pthread_create(&uss_task,&attr_uss,uss_thread,NULL);
		pthread_create(&motor_task1, &attr_motor1,original_straight_thread,motion_param);
//		pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
		pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
		pthread_join(uss_task,NULL);
		pthread_join(motor_task1, NULL);
//		pthread_join(motor_task2, NULL);
		pthread_join(irs_ts_ws_task,NULL);
	}
	if(exit_flag==3){
		uss_use=1;
		pthread_create(&uss_task,&attr_uss,uss_thread,NULL);
		pthread_create(&motor_task1, &attr_motor1,original_straight_thread,motion_param);
//		pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
		pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
		pthread_join(uss_task,NULL);
		pthread_join(motor_task1, NULL);
//		pthread_join(motor_task2, NULL);
		pthread_join(irs_ts_ws_task,NULL);
	}
	if(r_uss_wall_flag==0||l_uss_wall_flag==0){
		sprintf((char*)word,"e'ru  /a'i  /o'-  /e'nu  /ra'i--n   ");
		talk(word);
		rotary_flag=0;
		usleep(10000);
		step=0;
	}
}
/*
void r_step8(void){
	time(&start_time);
	if(exit_flag==9||exit_flag==12){
		motion_param[0]=ROT_A_STEP4_ANGLE;
		motion_param[1]=ROT_A_STEP4_TIME;
		motion_param[4]=5;
		fprintf(fp,"motion_param=%d\n",motion_param[0]);
		fclose_open('f');
		fprintf(fp,"motion_param=%d\n",motion_param[1]);
		fclose_open('f');
		pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,motion_param);
//		pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
		pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
		pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
		pthread_join(timer_task, NULL);
		pthread_join(motor_task1, NULL);
//		pthread_join(motor_task2, NULL);
		pthread_join(irs_ts_ws_task,NULL);
		if(const_flag==1)step=9;
	}

	if(exit_flag==3){
		motion_param[0]=ROT_B_STEP4_ANGLE;
		motion_param[1]=ROT_B_STEP4_TIME;
		motion_param[4]=5;
		fprintf(fp,"motion_param=%d\n",motion_param[0]);
		fclose_open('f');
		fprintf(fp,"motion_param=%d\n",motion_param[1]);
		fclose_open('f');
		pthread_create(&motor_task1, &attr_motor1,const_rotate_thread,motion_param);
//		pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
		pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
		pthread_create(&timer_task, &attr_timer,timer_thread,NULL);
		pthread_join(timer_task, NULL);
		pthread_join(motor_task1, NULL);
//		pthread_join(motor_task2, NULL);
		pthread_join(irs_ts_ws_task,NULL);
		if(const_flag==1||time_end_flag==1)step=9;
	}
}

void rotary_end(void){
	char s[100];
	sprintf((char*)s,"shabadwubi/ta'ttihenn;si-n",(char*)s);
	talk(s);
	motion_param[0]=ROT_EXIT_VAL;
	motion_param[1]=ROT_EXIT_TIME;
	pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws,irs_ts_ws_thread,NULL);
	pthread_create(&motor_task1, &attr_motor1,const_straight_thread,motion_param);
//	pthread_create(&motor_task2, &attr_motor2,sub_motor_thread,NULL);
	pthread_join(motor_task1, NULL);
//	pthread_join(motor_task2, NULL);
	pthread_join(irs_ts_ws_task,NULL);
	if(const_flag==1)step=0;
}
*/

