#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>

#include "../main/func_extern.h"
#include "../main/control.h"
#include "../uss/uss.h"
#include "../motor/motor.h"
#include "../original/uss_control.h"


extern int uss_exit_flag;
extern int obst,obst_keep;
extern int kobeya_flag;
extern int kobeya_exit_flag;

extern int r1_def,l1_def,l2_def;

extern FILE *fp;

//int uss_const_flag=0;
int uss_use;
int uss_pid;
int r_uss_wall_flag;
int r_uss_wall_ap_flag;
int l_uss_wall_flag;
int l_uss_wall_ap_flag;


pthread_mutex_t mutex_uss;


void *uss_thread(void){
	int i;
	double pre_uss_pid1=0;
	int p_error1=0;
	int i_sum1=0;
	int d_diff1=0;
	double pre_uss_pid2=0;
	int p_error2=0;
	int i_sum2=0;
	int d_diff2=0;
	int j[3]={3,2,4}; //USSの順番で
	int pre_uss_data[3]={0,0,0};
	int uss_data_thread[3]={0,0,0};
	int pre_uss_data_tmp[3];
	int uss_data_tmp[3]={0,0,0};
	int uss_dif[3]={0,0,0};
	//int r_dif,l_dif;
	int wall_counter[3]={0,0,0};
	int wall_ap_counter[3]={0,0,0};
	int uss_wall_flag[3]={1,1,1};
	int uss_wall_ap_flag[3]={0,0,0};
	int kobeya_exit_counter=0;
	int p_gain1=0;
	int i_gain1=0;
	int d_gain1=0;
	int p_gain2=0;
	int i_gain2=0;
	int d_gain2=0;
	uss_pid=0;
	r_uss_wall_flag=1;
	r_uss_wall_ap_flag=0;
	l_uss_wall_flag=1;
	l_uss_wall_ap_flag=0;
	//r_dif=0;l_dif=0;
	uss_exit_flag=0;

	if(uss_use==21){
		p_gain1=S_P_GAIN1;
		i_gain1=S_I_GAIN1;
		d_gain1=S_D_GAIN1;
		p_gain2=S_P_GAIN2;
		i_gain2=S_I_GAIN2;
		d_gain2=S_D_GAIN2;
	}
	if(uss_use==20){
		p_gain1=0;
		i_gain1=0;
		d_gain1=0;
		p_gain2=KL_P_GAIN2;
		i_gain2=KL_I_GAIN2;
		d_gain2=KL_D_GAIN2;
	}
	if(uss_use==10||uss_use==1){
		p_gain1=R_P_GAIN1;
		i_gain1=R_I_GAIN1;
		d_gain1=R_D_GAIN1;
		p_gain2=0;
		i_gain2=0;
		d_gain2=0;
	}

	printf("uss thread in\n");
	fprintf(fp,"uss_thread\n");
	for(i=0;i<3;i++){
		pre_uss_data_tmp[j[i]-2]=uss_get(j[i]);
		uss_data_tmp[j[i]-2]=pre_uss_data_tmp[j[i]-2];
		uss_data_thread[j[i]-2]=22;
		usleep(S_TIME);
	}	
	while(1){
		for(i=0;i<3;i++){
			pre_uss_data[j[i]-2]=uss_get(j[i]);
			//if(pre_uss_data[j[i]-2] < 20)pre_uss_data[j[i]-2]=20;
			fprintf(fp,"uss[%d] = %d\n",j[i],pre_uss_data[j[i]-2]);
			fclose_open('f');
			uss_dif[j[i]-2]=pre_uss_data[j[i]-2] -pre_uss_data_tmp[j[i]-2];
			if(uss_dif[j[i]-2] >= USS_WALL)uss_wall_flag[j[i]-2]=0;
/*
			if(uss_dif[j[i]-2] <= -USS_WALL){
				uss_wall_flag[j[i]-2]=1;
				uss_wall_ap_flag[j[i]-2]=1;
			}
*/
			//if(obst == 3){
			if(pre_uss_data[j[i]-2] >= 50)wall_counter[j[i]-2]++;
			if(pre_uss_data[j[i]-2] < 50 )wall_counter[j[i]-2]=0;
			if(wall_counter[j[i]-2]==2)uss_wall_flag[j[i]-2]=0;
			//}
			fprintf(fp,"wall[%d] = %d\nwall_counter[%d] = %d\n",j[i],uss_wall_flag[j[i]-2],j[i],wall_counter[j[i]-2]);
			if(uss_wall_flag[j[i]-2]==0 && pre_uss_data[j[i]-2] < 40)wall_ap_counter[j[i]-2]++;
			if(uss_wall_flag[j[i]-2]==0 && pre_uss_data[j[i]-2] > 40)wall_ap_counter[j[i]-2]=0;
			if(wall_ap_counter[j[i]-2]==3){
				uss_wall_flag[j[i]-2]=1;
				uss_wall_ap_flag[j[i]-2]=1;
			}

			if(uss_wall_flag[j[i]-2]==0){
				uss_data_thread[j[i]-2]=20;
			}else if(pre_uss_data[j[i]-2] >= 350){
				uss_data_thread[j[i]-2]=350;
			}else{
				uss_data_thread[j[i]-2]=pre_uss_data[j[i]-2];
			}

			if(uss_wall_flag[0]==0&&obst!=2&&uss_use!=1)l_uss_wall_flag=0;
			if(uss_wall_flag[0]==1)l_uss_wall_flag=1;
			if(uss_wall_ap_flag[0]==1)l_uss_wall_ap_flag=1;
			if(uss_wall_flag[1]==0&&obst!=2&&uss_use!=10&&uss_use!=20)r_uss_wall_flag=0;
			if(uss_wall_flag[1]==1)r_uss_wall_flag=1;
			if(uss_wall_ap_flag[1]==1)r_uss_wall_ap_flag=1;
			if(uss_wall_ap_flag[0]==1&&obst==2)obst=obst_keep;
			if(uss_wall_ap_flag[1]==1&&obst==2)obst=obst_keep;
			usleep(S_TIME);
		}
		/*
		if(uss_data_thread[0]!=20&&uss_data_thread[1]!=20){
			if(uss_data_thread[0]<=uss_const_dis||uss_data_thread[1]<=uss_const_dis){
				uss_const_flag=1;
			}else{
				uss_const_flag=0;
			}
		}
		*/
		//r_dif=uss_data_thread[0] - R_MIDDLE;
		//l_dif=uss_data_thread[1] - L_MIDDLE;
		
		//if(kobeya_flag==1&&uss_wall_flag[0]==1&&uss_wall_flag[1]==1)
		if(kobeya_flag==1&&pre_uss_data[0]<40&&pre_uss_data[1]<40)kobeya_exit_counter++;
		if(kobeya_flag!=1||pre_uss_data[0]>40||pre_uss_data[1]>40)kobeya_exit_counter=0;
		if(kobeya_exit_counter==4){
			kobeya_exit_flag=1;
			fprintf(fp,"/////kobeya_exit/////");
			fclose_open('f');
		}

		if(uss_use==10||uss_use==20)uss_data_thread[1]=r1_def;
		if(uss_use==1)uss_data_thread[0]=l1_def;
		if(uss_use==1||uss_use==10||uss_use==11)uss_data_thread[2]=l2_def;

		if(uss_use!=20){
			p_error1 = (r1_def-l1_def)-(uss_data_thread[1]-uss_data_thread[0]);
			i_sum1 += p_error1;
			d_diff1 = (uss_data_tmp[1]-uss_data_tmp[0])-(uss_data_thread[1]-uss_data_thread[0]);
			pre_uss_pid1 = (p_gain1 * (double)p_error1 / 100) + (i_gain1 * (double)i_sum1 / 100) + (d_gain1 * (double)d_diff1 / 100);
		}else pre_uss_pid1=0;
		if(uss_use!=11||uss_use!=10){
			p_error2 = (l2_def-l1_def-(l2_def+l1_def)/2)-(uss_data_thread[2]-uss_data_thread[0]-(uss_data_thread[2]+uss_data_thread[0])/2);
			i_sum2 += p_error2;
			d_diff2 = (uss_data_tmp[2]-uss_data_tmp[0]-(uss_data_tmp[2]+uss_data_tmp[0])/2)-(uss_data_thread[2]-uss_data_thread[0]-(uss_data_thread[2]+uss_data_thread[0])/2);
			pre_uss_pid2 = (p_gain2 * (double)p_error2 / 100) + (i_gain2 * (double)i_sum2 / 100) + (d_gain2 * (double)d_diff2 / 100);
		}else pre_uss_pid2=0;

		uss_pid = (int)pre_uss_pid1 + (int) pre_uss_pid2;
		fprintf(fp,"p_error = %d\ni_sum = %d\nuss_pid = %d\n",p_error1,i_sum1,uss_pid);
		fclose_open('f');
		for(i=0;i<3;i++){
			pre_uss_data_tmp[i]=pre_uss_data[i];
			uss_data_tmp[i]=uss_data_thread[i];
		}
		
		if(uss_exit_flag==1){
			printf("uss_thread exit\n");
			pthread_exit(0);
		}
	}
	return 0;
}
